#!/usr/bin/python3

# carico moduli
from __future__ import division
import os
import sys
import time
import PyTango
import numpy as np
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from matplotlib.backends.backend_qt4agg import FigureCanvasQTAgg as FigureCanvas
import matplotlib.pyplot as plt

# variabili globali
chiaccherone = 1
limite_attenuatore = [45, 90]
sacco = {}
sacco['calendario'] = PyTango.DeviceProxy('sl/laser/calendar_sl.01')
sacco['f-ms'] = PyTango.DeviceProxy('f/misc/beam_status_f')
sacco['parametrisalvati'] = PyTango.DeviceProxy('sl/misc/ranges')
sacco['io'] = PyTango.DeviceProxy('sl/io/lsh_sl.01')
sacco['io2'] = PyTango.DeviceProxy('sl/io/lsh_sl.02')
sacco['trls4'] = PyTango.DeviceProxy('sl/motor/trls_sl.04')
sacco['trls8'] = PyTango.DeviceProxy('sl/motor/trls_sl.08')
sacco['opti0'] = PyTango.DeviceProxy('f/optimization/optimizer_sldelay_f.01')
sacco['opti1'] = PyTango.DeviceProxy('f/optimization/corrmin_f.01')
sacco['opti2'] = PyTango.DeviceProxy('f/optimization/corrmin_f.02')
sacco['opti3'] = PyTango.DeviceProxy('f/optimization/corrmin_f.03')
sacco['opti4'] = PyTango.DeviceProxy('f/optimization/corrmin_f.04')
sacco['fbseqslow'] = PyTango.DeviceProxy('seq/restore/rtltf_corr_slow')
sacco['fbseqfast'] = PyTango.DeviceProxy('seq/restore/rtltf_corr_fast')

tmp = sacco['calendario'].activityNum
print('activity ' + str(tmp))
if tmp == 0:
    chevergognafarloamano = 'F1O'
elif 0 < tmp < 3:
    chevergognafarloamano = 'F1O'
elif 2 < tmp < 7:
    chevergognafarloamano = 'F1T'
elif 6 < tmp < 9:
    chevergognafarloamano = 'F2T'
elif 8 < tmp < 11:
    chevergognafarloamano = 'F2O'

if chevergognafarloamano == 'F2O':
    sacco['mpsattenuator'] = PyTango.DeviceProxy('f/interlock/shut_att_fel02.01') ##
    sacco['mpsshutter'] = PyTango.DeviceProxy('slu/interlock/bsh_fel02.01') ##
    sacco['attenuator'] = PyTango.DeviceProxy('sl/motor/rots_sl.16') ##
    sacco['fbenergy'] = PyTango.DeviceProxy('sl/feedback/fb_opa_energy_fel02.01') ##
    sacco['emcalib'] = PyTango.DeviceProxy('sl/energy_meter/emcalib_sl.02') ##
    sacco['emuv'] = PyTango.DeviceProxy('sl/energy_meter/ems_sl.04') ##
    sacco['fastdelayscan'] = PyTango.DeviceProxy('opt/fel02/fine_delay_sl.01') ##
    sacco['relaxfelfb'] = PyTango.DeviceProxy('sl/feedback/fb_relax_rtltf_fel02.01') ##
    sacco['ccd1'] = PyTango.DeviceProxy('sl/diagnostics/ccd_sl.10') ##
    sacco['ccd2'] = PyTango.DeviceProxy('sl/diagnostics/ccd_sl.12') ##
    sacco['felfb'] = PyTango.DeviceProxy('sl/feedback/rtltf_fel02.01') ##
    sacco['felfbrelax'] = PyTango.DeviceProxy('sl/feedback/fb_relax_rtltf_fel02.01') ##
    sacco['schermo1ccd'] = PyTango.DeviceProxy('sfel02/diagnostics/mscrccd_sfel02.02') ##
    sacco['schermo1'] = PyTango.DeviceProxy('sfel02/diagnostics/mscr_sfel02.02') ##
    sacco['schermo2ccd'] = PyTango.DeviceProxy('fel02/diagnostics/mscrccd_fel02.01') ##
    sacco['schermo2'] = PyTango.DeviceProxy('fel02/mover2d/mscr_fel02.01') ##
    sacco['schermo2_filter'] = PyTango.DeviceProxy('fel02/diagnostics/mscr_rots_fel02.01') ##
    sacco['schermo3ccd'] = PyTango.DeviceProxy('iufel02/diagnostics/mscrccd_iufel02.02') ##
    sacco['schermo3'] = PyTango.DeviceProxy('iufel02/mover2d/mscr_iufel02.02') ##
    sacco['schermo3_filter'] = PyTango.DeviceProxy('iufel02/diagnostics/mscr_rots_iufel02.02') ##
    sacco['sptcm'] = PyTango.DeviceProxy('sl/diagnostics/spctm_uv_slr.01') ##
    sacco['opa'] = PyTango.DeviceProxy('sl/laser/opa_sl.02') ##
elif chevergognafarloamano == 'F1O':
    sacco['mpsattenuator'] = PyTango.DeviceProxy('f/interlock/shut_att_fel01.01') ##
    sacco['mpsshutter'] = PyTango.DeviceProxy('slu/interlock/bsh_fel01.01') ##
    sacco['attenuator'] = PyTango.DeviceProxy('sl/motor/rots_sl.14') ##
    sacco['fbenergy'] = PyTango.DeviceProxy('sl/feedback/fb_opa_energy_fel01.01') ##
    sacco['emcalib'] = PyTango.DeviceProxy('sl/energy_meter/emcalib_sl.01') ##
    sacco['emuv'] = PyTango.DeviceProxy('sl/energy_meter/ems_sl.02') ##
    sacco['fastdelayscan'] = PyTango.DeviceProxy('opt/fel02/fine_delay_sl.01') ##
    sacco['relaxfelfb'] = PyTango.DeviceProxy('sl/feedback/fb_relax_rtltf_fel01.01') ##
    sacco['ccd1'] = PyTango.DeviceProxy('sl/diagnostics/ccd_sl.05') ##
    sacco['ccd2'] = PyTango.DeviceProxy('sl/diagnostics/ccd_sl.07') ##
    sacco['felfb'] = PyTango.DeviceProxy('sl/feedback/rtltf_fel01.01') ##
    sacco['felfbrelax'] = PyTango.DeviceProxy('sl/feedback/fb_relax_rtltf_fel02.01') ##
    sacco['schermo1ccd'] = PyTango.DeviceProxy('sfel01/diagnostics/mscrccd_sfel01.02') ##
    sacco['schermo1'] = PyTango.DeviceProxy('sfel01/diagnostics/mscr_sfel01.02') ##
    sacco['schermo2ccd'] = PyTango.DeviceProxy('fel01/diagnostics/mscrccd_fel01.01') ##
    sacco['schermo2'] = PyTango.DeviceProxy('fel01/mover2d/mscr_fel01.01') ##
    sacco['schermo2_filter'] = PyTango.DeviceProxy('fel01/diagnostics/mscr_rots_fel01.01') ##
    sacco['schermo3ccd'] = PyTango.DeviceProxy('iufel01/diagnostics/mscrccd_iufel01.02') ##
    sacco['schermo3'] = PyTango.DeviceProxy('iufel01/mover2d/mscr_iufel01.02') ##
    sacco['schermo3_filter'] = PyTango.DeviceProxy('iufel01/diagnostics/mscr_rots_iufel01.02') ##
    sacco['sptcm'] = PyTango.DeviceProxy('sl/diagnostics/spctm_uv_slr.02') ##
    sacco['opa'] = PyTango.DeviceProxy('sl/laser/opa_sl.01') ##
elif chevergognafarloamano == 'F2T':
    sacco['mpsattenuator'] = PyTango.DeviceProxy('f/interlock/shut_att_fel02.01') ##
    sacco['mpsshutter'] = PyTango.DeviceProxy('slu/interlock/bsh_fel02.01') ##
    sacco['attenuator'] = PyTango.DeviceProxy('sl/motor/rots_sl.09') ##
    sacco['emcalib'] = PyTango.DeviceProxy('sl/energy_meter/emcalib_sl.02') ##
    sacco['emuv'] = PyTango.DeviceProxy('sl/energy_meter/ems_sl.04') ##
    sacco['fastdelayscan'] = PyTango.DeviceProxy('opt/fel02/fine_delay_sl.01') ##
    sacco['relaxfelfb'] = PyTango.DeviceProxy('sl/feedback/fb_relax_rtltf_fel02.01') ##
    sacco['ccd1'] = PyTango.DeviceProxy('sl/diagnostics/ccd_sl.10') ##
    sacco['ccd2'] = PyTango.DeviceProxy('sl/diagnostics/ccd_sl.12') ##
    sacco['felfb'] = PyTango.DeviceProxy('sl/feedback/rtltf_fel02.01') ##
    sacco['felfbrelax'] = PyTango.DeviceProxy('sl/feedback/fb_relax_rtltf_fel02.01') ##
    sacco['schermo1ccd'] = PyTango.DeviceProxy('sfel02/diagnostics/mscrccd_sfel02.02') ##
    sacco['schermo1'] = PyTango.DeviceProxy('sfel02/diagnostics/mscr_sfel02.02') ##
    sacco['schermo2ccd'] = PyTango.DeviceProxy('fel02/diagnostics/mscrccd_fel02.01') ##
    sacco['schermo2'] = PyTango.DeviceProxy('fel02/mover2d/mscr_fel02.01') ##
    sacco['schermo2_filter'] = PyTango.DeviceProxy('fel02/diagnostics/mscr_rots_fel02.01') ##
    sacco['schermo3ccd'] = PyTango.DeviceProxy('iufel02/diagnostics/mscrccd_iufel02.02') ##
    sacco['schermo3'] = PyTango.DeviceProxy('iufel02/mover2d/mscr_iufel02.02') ##
    sacco['schermo3_filter'] = PyTango.DeviceProxy('iufel02/diagnostics/mscr_rots_iufel02.02') ##
    sacco['sptcm'] = PyTango.DeviceProxy('sl/diagnostics/spctm_uv_slr.01') ##
    sacco['thgxtal'] = PyTango.DeviceProxy('sl/motor/rots_sl.08')
elif chevergognafarloamano == 'F1T':
    sacco['mpsattenuator'] = PyTango.DeviceProxy('f/interlock/shut_att_fel01.01') ##
    sacco['mpsshutter'] = PyTango.DeviceProxy('slu/interlock/bsh_fel01.01') ##
    sacco['attenuator'] = PyTango.DeviceProxy('sl/motor/rots_sl.09') ##
    sacco['emcalib'] = PyTango.DeviceProxy('sl/energy_meter/emcalib_sl.01') ##
    sacco['emuv'] = PyTango.DeviceProxy('sl/energy_meter/ems_sl.02') ##
    sacco['fastdelayscan'] = PyTango.DeviceProxy('opt/fel02/fine_delay_sl.01') ##
    sacco['relaxfelfb'] = PyTango.DeviceProxy('sl/feedback/fb_relax_rtltf_fel01.01') ##
    sacco['ccd1'] = PyTango.DeviceProxy('sl/diagnostics/ccd_sl.05') ##
    sacco['ccd2'] = PyTango.DeviceProxy('sl/diagnostics/ccd_sl.07') ##
    sacco['felfb'] = PyTango.DeviceProxy('sl/feedback/rtltf_fel01.01') ##
    sacco['felfbrelax'] = PyTango.DeviceProxy('sl/feedback/fb_relax_rtltf_fel01.01') ##
    sacco['schermo1ccd'] = PyTango.DeviceProxy('sfel01/diagnostics/mscrccd_sfel01.02') ##
    sacco['schermo1'] = PyTango.DeviceProxy('sfel01/diagnostics/mscr_sfel01.02') ##
    sacco['schermo2ccd'] = PyTango.DeviceProxy('fel01/diagnostics/mscrccd_fel01.01') ##
    sacco['schermo2'] = PyTango.DeviceProxy('fel01/mover2d/mscr_fel01.01') ##
    sacco['schermo2_filter'] = PyTango.DeviceProxy('fel01/diagnostics/mscr_rots_fel01.01') ##
    sacco['schermo3ccd'] = PyTango.DeviceProxy('iufel01/diagnostics/mscrccd_iufel01.02') ##
    sacco['schermo3'] = PyTango.DeviceProxy('iufel01/mover2d/mscr_iufel01.02') ##
    sacco['schermo3_filter'] = PyTango.DeviceProxy('iufel01/diagnostics/mscr_rots_iufel01.02') ##
    sacco['sptcm'] = PyTango.DeviceProxy('sl/diagnostics/spctm_uv_slr.02') ##
    sacco['thgxtal'] = PyTango.DeviceProxy('sl/motor/rots_sl.02')



class MainWindow(QDialog):
    def __init__(self, parent=None):
        super(MainWindow, self).__init__(parent)
        if chevergognafarloamano == 'F2O':
            self.titolo = QLabel("SL OPA for FEL2") ##
        elif chevergognafarloamano == 'F2T':
            self.titolo = QLabel("SL THG for FEL2") ##
        if chevergognafarloamano == 'F1O':
            self.titolo = QLabel("SL OPA for FEL1") ##
        elif chevergognafarloamano == 'F1T':
            self.titolo = QLabel("SL THG for FEL1") ##
        self.titolo.setFont(font_grande)
        self.robaautomatica = QFrame()
        self.robashutter = QFrame()
        self.robaenergetica = QFrame()
        self.robacolorata = QFrame()
        self.robatemporale = QFrame()
        self.robaspaziale = QFrame()
        self.robaditesto = QFrame()
        self.contenitore = QToolBox()
        self.contenitore.insertItem(0, self.robaditesto, 'Messages')
        self.contenitore.insertItem(1, self.robashutter, 'Shutter:')
        self.contenitore.insertItem(2, self.robaenergetica, 'Energy:')
        self.contenitore.insertItem(3, self.robacolorata, 'Wavelenght:')
        self.contenitore.insertItem(4, self.robatemporale, 'Timing:')
        self.contenitore.insertItem(5, self.robaspaziale, 'Pointing:')
        # messaggi
        self.casellamessaggi = QListWidget()
        self.antistress = QPushButton('stress')
        self.wiki = QPushButton('WIKI')
        self.antistress.clicked.connect(self.faqualcosa)
        self.messaggi_LO = QGridLayout()
        self.messaggi_LO.addWidget(self.casellamessaggi, 0, 0, 1, 2)
        self.messaggi_LO.addWidget(self.wiki, 1, 0)
        self.messaggi_LO.addWidget(self.antistress, 1, 1)
        self.robaditesto.setLayout(self.messaggi_LO)
        # shutters
        self.shutter_openshutter = QPushButton('Open shutter')
        self.shutter_openshutter.clicked.connect(self.mpsshutout)
        self.shutter_closeshutter = QPushButton('Close shutter')
        self.shutter_closeshutter.clicked.connect(self.mpsshutin)
        self.shutter_removeattenuator = QPushButton('Remove attenuator')
        self.shutter_removeattenuator.clicked.connect(self.mpsattout)
        self.shutter_insertattenuator = QPushButton('Insert attenutor')
        self.shutter_insertattenuator.clicked.connect(self.mpsattin)
        self.shutter_LO = QGridLayout()
        self.shutter_LO.addWidget(self.shutter_openshutter, 0, 0)
        self.shutter_LO.addWidget(self.shutter_closeshutter, 0, 1)
        self.shutter_LO.addWidget(self.shutter_removeattenuator, 1, 0)
        self.shutter_LO.addWidget(self.shutter_insertattenuator, 1, 1)
        self.robashutter.setLayout(self.shutter_LO)
        # energy
        self.energy_barra = QProgressBar()
        self.energy_barra.setRange(0, 30)
        if chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F1O':
            self.energy_feedback_tasto = QPushButton('energy feedback')
            self.energy_feedback_tasto.clicked.connect(self.lancia_pannello_energyfeedback)
            self.energy_feedback_setvalue = QDoubleSpinBox()
            self.energy_feedback_setvalue.setRange(0.0, 40.0)
            self.energy_feedback_setvalue.setSingleStep(0.5)
            self.energy_feedback_set = QPushButton('Apply')
            self.energy_feedback_set.clicked.connect(self.change_energy)
            self.energy_feedback_on = QPushButton('ON')
            self.energy_feedback_on.clicked.connect(self.feedback_energia_smart_on)
            self.energy_feedback_sb = QPushButton('Standby')
            self.energy_feedback_sb.clicked.connect(self.feedback_energia_sb)
        self.energy_attenuator_tasto = QPushButton('attenuator')
        self.energy_attenuator_tasto.clicked.connect(self.lancia_pannello_attenuatore)
        self.energy_attenuator_setvalue = QDoubleSpinBox()
        self.energy_attenuator_setvalue.setRange(0.0, 90.0)
        self.energy_attenuator_setvalue.setSingleStep(0.5)
        self.energy_attenuator_set = QPushButton('Apply')
        self.energy_attenuator_set.clicked.connect(self.change_attenuator)
        self.energy_LO = QGridLayout()
        if chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F1O':
            self.energy_LO.addWidget(self.energy_barra, 0, 0, 1, 5)
            self.energy_LO.addWidget(self.energy_feedback_tasto, 1, 0)
            self.energy_LO.addWidget(self.energy_feedback_setvalue, 1, 1)
            self.energy_LO.addWidget(self.energy_feedback_set, 1, 2)
            self.energy_LO.addWidget(self.energy_feedback_on, 1, 3)
            self.energy_LO.addWidget(self.energy_feedback_sb, 1, 4)
            self.energy_LO.addWidget(QHLine(), 2, 0, 1, 5)
        self.energy_LO.addWidget(self.energy_attenuator_tasto, 10, 0)
        self.energy_LO.addWidget(self.energy_attenuator_setvalue, 10, 1)
        self.energy_LO.addWidget(self.energy_attenuator_set, 10, 2)
        self.robaenergetica.setLayout(self.energy_LO)
        # wavelenght
        if chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F1O':
            self.wavelenght_set = QLineEdit()
            self.wavelenght_apply = QPushButton('Apply')
            self.wavelenght_apply.clicked.connect(self.setopa)
        elif chevergognafarloamano == 'F2T' or chevergognafarloamano == 'F1T':
            self.wavelenght_stringa1 = QLabel('THG motor deg:')
            self.wavelenght_read = LineEditRO()
            self.wavelenght_stringa2 = QLabel('?deg = ?nm (1deg~=?nm)')
            self.wavelenght_down = QPushButton('<')
            self.wavelenght_down.clicked.connect(self.thgxtadown)
            self.wavelenght_step = QLineEdit('0.1')
            self.wavelenght_up = QPushButton('>')
            self.wavelenght_up.clicked.connect(self.thgxtaup)
        self.wavelenght_figura = plt.figure()
        self.wavelenght_canvas = FigureCanvas(self.wavelenght_figura)
        self.wavelenght_subp = self.wavelenght_figura.add_subplot(111)
        self.wavelenght_LO = QGridLayout()
        if chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F1O':
            self.wavelenght_LO.addWidget(self.wavelenght_set, 0, 0)
            self.wavelenght_LO.addWidget(self.wavelenght_apply, 0, 1)
        elif chevergognafarloamano == 'F2T' or chevergognafarloamano == 'F1T':
            self.wavelenght_LO.addWidget(self.wavelenght_stringa1, 0, 0)
            self.wavelenght_LO.addWidget(self.wavelenght_read, 0, 1)
            self.wavelenght_LO.addWidget(self.wavelenght_stringa2, 1, 0, 1, 3)
            self.wavelenght_LO.addWidget(self.wavelenght_down, 3, 0)
            self.wavelenght_LO.addWidget(self.wavelenght_step, 3, 1)
            self.wavelenght_LO.addWidget(self.wavelenght_up, 3, 2)
        self.wavelenght_LO.addWidget(self.wavelenght_canvas, 20, 0, 3, 3)
        self.robacolorata.setLayout(self.wavelenght_LO)
        # timing
        self.timing_targetlabel = QLabel('Target:')
        self.timing_target = LineEditRO()
        self.timing_targetlist = QComboBox()
        self.timing_targetlist.hide()
        self.timing_targetconfig = QPushButton('change')
        self.timing_targetconfig.clicked.connect(self.campi_target_timing)
        self.timing_targetapply = QPushButton('Apply')
        self.timing_targetapply.clicked.connect(self.cambio_target_timing)
        self.timing_targetapply.hide()
        self.timing_corrmin_tasto = QPushButton('cor.min.delay')
        self.timing_corrmin_tasto.clicked.connect(self.lancia_optdelay)
        self.timing_corrmin_state = LineEditRO()
        self.timing_corrmin_on = QPushButton('ON')
        self.timing_corrmin_on.clicked.connect(self.corrmidelon)
        self.timing_corrmin_sb = QPushButton('Standby')
        self.timing_corrmin_sb.clicked.connect(self.corrmindelsb)
        self.timing_fastscan_scanA = QPushButton('Fscan 100fs')
        self.timing_fastscan_scanA.clicked.connect(self.fastdelayscanA)
        self.timing_fastscan_scanB = QPushButton('Fscan 400fs')
        self.timing_fastscan_scanB.clicked.connect(self.fastdelayscanB)
        self.timing_fastscan_scanC = QPushButton('Fscan 3ps')
        self.timing_fastscan_scanC.clicked.connect(self.fastdelayscanC)
        self.timing_fastscan_config = QPushButton('configure')
        self.timing_fastscan_config.clicked.connect(self.configura_mimo_fastscan)
        self.timing_trls4_helpstring = QLabel('Use this for everything, EXCEPT wavelength changes')
        self.timing_trls4_readposition = LineEditRO()
        self.timing_trls4_setposition = QDoubleSpinBox()
        self.timing_trls4_setposition.setRange(-3300, 3300)
        self.timing_trls4_setposition.setSingleStep(0.1)
        self.timing_trls4_go = QPushButton('GO')
        self.timing_trls4_go.clicked.connect(self.trls4go)
        self.timing_trls4_relativesx = QPushButton('<')
        self.timing_trls4_relativesx.clicked.connect(self.trls4torna)
        self.timing_trls4_realtivestep = QLineEdit()
        self.timing_trls4_relativedx = QPushButton('>')
        self.timing_trls4_relativedx.clicked.connect(self.trls4vai)
        self.timing_trls4_speedread = LineEditRO()
        self.timing_trls4_speedwrite = QDoubleSpinBox()
        self.timing_trls4_speedset = QPushButton('set')
        self.timing_trls4_speedset.clicked.connect(self.trls4speed)
        self.timing_trls8_helpstring = QLabel('Use this ONLY for wavelength changes')
        self.timing_trls8_readposition = LineEditRO()
        self.timing_trls8_setposition = QDoubleSpinBox()
        self.timing_trls8_setposition.setRange(-6600, 6600)
        self.timing_trls8_setposition.setSingleStep(0.1)
        self.timing_trls8_go = QPushButton('GO')
        self.timing_trls8_go.clicked.connect(self.trls8go)
        self.timing_trls8_relativesx = QPushButton('<')
        self.timing_trls8_relativesx.clicked.connect(self.trls8torna)
        self.timing_trls8_realtivestep = QLineEdit()
        self.timing_trls8_relativedx = QPushButton('>')
        self.timing_trls8_relativedx.clicked.connect(self.trls8vai)
        self.timing_trls8_speedread = LineEditRO()
        self.timing_trls8_speedwrite = QDoubleSpinBox()
        self.timing_trls8_speedset = QPushButton('set')
        self.timing_trls8_speedset.clicked.connect(self.trls8speed)
        self.timing_triggerpanel = QPushButton('Trigger panel')
        self.timing_triggerpanel.setDisabled(1)
        # .clicked.connect(self.)
        self.timing_triggerdecimator = QPushButton('decimator')
        self.timing_triggerdecimator.setDisabled(1)
        # .clicked.connect(self.)
        self.timing_EOSprocedure = QPushButton('Start guided EOS photodiode procedure')
        self.timing_EOSprocedure.setDisabled(1)
        # .clicked.connect(self.)
        # fb
        self.timing_eosprocedure_scope = QPushButton('')
        self.timing_LO = QGridLayout()
        self.timing_LO.addWidget(self.timing_targetlabel, 0, 0)
        self.timing_LO.addWidget(self.timing_target, 0, 1, 1, 5)
        self.timing_LO.addWidget(self.timing_targetlist, 0, 1, 1, 5)
        self.timing_LO.addWidget(self.timing_targetconfig, 0, 6, 1, 2)
        self.timing_LO.addWidget(self.timing_targetapply, 0, 6, 1, 2)
        self.timing_LO.addWidget(self.timing_corrmin_tasto, 10, 0, 1, 2)
        self.timing_LO.addWidget(self.timing_corrmin_state, 10, 2, 1, 2)
        self.timing_LO.addWidget(self.timing_corrmin_on, 10, 4, 1, 2)
        self.timing_LO.addWidget(self.timing_corrmin_sb, 10, 6, 1, 2)
        self.timing_LO.addWidget(QHLine(), 19, 0, 1, 8)
        self.timing_LO.addWidget(self.timing_fastscan_scanA, 20, 0, 1, 2)
        self.timing_LO.addWidget(self.timing_fastscan_scanB, 20, 2, 1, 2)
        self.timing_LO.addWidget(self.timing_fastscan_scanC, 20, 4, 1, 2)
        self.timing_LO.addWidget(self.timing_fastscan_config, 20, 6, 1, 2)
        self.timing_LO.addWidget(QHLine(), 29, 0, 1, 8)
        self.timing_LO.addWidget(self.timing_trls4_helpstring, 30, 0, 1, 8)
        self.timing_LO.addWidget(QLabel('trls4 Pos: '), 31, 0)
        self.timing_LO.addWidget(self.timing_trls4_readposition, 31, 1)
        self.timing_LO.addWidget(self.timing_trls4_setposition, 31, 2)
        self.timing_LO.addWidget(self.timing_trls4_go, 31, 3)
        self.timing_LO.addWidget(self.timing_trls4_relativesx, 31, 4)
        self.timing_LO.addWidget(self.timing_trls4_realtivestep, 31, 5, 1, 2)
        self.timing_LO.addWidget(self.timing_trls4_relativedx, 31, 7)
        self.timing_LO.addWidget(QLabel('trls4 speed: '), 32, 0)
        self.timing_LO.addWidget(self.timing_trls4_speedread, 32, 1)
        self.timing_LO.addWidget(self.timing_trls4_speedwrite, 32, 2)
        self.timing_LO.addWidget(self.timing_trls4_speedset, 32, 3)
        self.timing_LO.addWidget(QHLine(), 39, 0, 1, 8)
        self.timing_LO.addWidget(self.timing_trls8_helpstring, 40, 0, 1, 8)
        self.timing_LO.addWidget(QLabel('trls8 Pos: '), 41, 0)
        self.timing_LO.addWidget(self.timing_trls8_readposition, 41, 1)
        self.timing_LO.addWidget(self.timing_trls8_setposition, 41, 2)
        self.timing_LO.addWidget(self.timing_trls8_go, 41, 3)
        self.timing_LO.addWidget(self.timing_trls8_relativesx, 41, 4)
        self.timing_LO.addWidget(self.timing_trls8_realtivestep, 41, 5, 1, 2)
        self.timing_LO.addWidget(self.timing_trls8_relativedx, 41, 7)
        self.timing_LO.addWidget(QLabel('trls8 speed: '), 42, 0)
        self.timing_LO.addWidget(self.timing_trls8_speedread, 42, 1)
        self.timing_LO.addWidget(self.timing_trls8_speedwrite, 42, 2)
        self.timing_LO.addWidget(self.timing_trls8_speedset, 42, 3)
        self.timing_LO.addWidget(QHLine(), 49, 0, 1, 8)
        self.timing_LO.addWidget(self.timing_triggerpanel, 50, 0, 1, 2)
        self.timing_LO.addWidget(self.timing_triggerdecimator, 50, 2, 1, 2)
        self.timing_LO.addWidget(self.timing_EOSprocedure, 50, 4, 1, 4)
        self.robatemporale.setLayout(self.timing_LO)
        # pointing
        self.pointing_optimization_style = LineEditRO()
        self.pointing_optimization_target = LineEditRO()
        self.pointing_optimization_targetlist = QComboBox()
        self.pointing_optimization_targetlist.hide()
        self.pointing_optimization_targetchange = QPushButton('config')
        self.pointing_optimization_targetchange.clicked.connect(self.campi_target_pointing)
        self.pointing_optimization_targetapply = QPushButton('Apply')
        self.pointing_optimization_targetapply.clicked.connect(self.cambio_target_pointing)
        self.pointing_optimization_targetapply.hide()
        self.pointing_optimization_off = QPushButton('OFF')
        self.pointing_optimization_off_l = QLabel('stop optimiziation, shakes and correlation minimizers')
        self.pointing_optimization_off.setSizePolicy(QSizePolicy.Preferred, QSizePolicy.Expanding)
        self.pointing_optimization_off.clicked.connect(self.spegniogniottimizzazione)
        self.pointing_optimization_standard = QPushButton('Standard')
        self.pointing_optimization_standard_l = QLabel('countdown type with spiral movement on 2 ccds to optimize together first and second point of the feedback')
        self.pointing_optimization_standard.clicked.connect(self.dajediottimizzazionestandard)
        self.pointing_optimization_infstandard = QPushButton('Infinite standard')
        self.pointing_optimization_infstandard_l = QLabel('infinite spiral movement on 2 ccds to optimize together first and second point of the feedback')
        self.pointing_optimization_infstandard.clicked.connect(self.dajediottimizzazionestandardsenzafine)
        self.pointing_optimization_infstandardshake = QPushButton('Infinite standard shakes values')
        self.pointing_optimization_infstandardshake_l = QLabel('infinite spiral movement with amplitude defined by shakes on 2 ccds to optimize together first and second point of the feedback')
        self.pointing_optimization_infstandardshake.clicked.connect(self.dajediottimizzazionestandardsenzafinemacoipesi)
#        self.pointing_optimization_configstandardopt = QPushButton('configure opti. standard')
#        self.pointing_optimization_configstandardopt_l = QLabel('ao')
#        self.pointing_optimization_configstandardopt.clicked.connect(self.lanciafbconfigure)
        self.pointing_optimization_shakeandcorrminALL = QPushButton('Shake and corr. min. ALL')
        self.pointing_optimization_shakeandcorrminALL_l = QLabel('continuous shakes on 2 ccds to optimize independently first and second point of the feedback with correlation minimizers')
        self.pointing_optimization_shakeandcorrminALL.clicked.connect(self.dajedishakeemincorglobale)
        self.pointing_optimization_shakeandcorrminVIRTUAL = QPushButton('Shake and corr. min. ccd2')
        self.pointing_optimization_shakeandcorrminVIRTUAL_l = QLabel('continuous shakes on second ccd to optimize only second point of the feedback with correlation minimizers')
        self.pointing_optimization_shakeandcorrminVIRTUAL.clicked.connect(self.dajedishakeemincorsolovirtuale)
        self.pointing_optimization_corrminALL = QPushButton('Corr. min. ALL')
        self.pointing_optimization_corrminALL_l = QLabel('optimize independently first and second point of the feedback with correlation minimizers without shake')
        self.pointing_optimization_corrminALL.clicked.connect(self.dajedimicorglobale)
        self.pointing_optimization_corrminVIRTUAL = QPushButton('Corr. min. ccd2')
        self.pointing_optimization_corrminVIRTUAL_l = QLabel('optimize the second point of the feedback with correlation minimizers without shake')
        self.pointing_optimization_corrminVIRTUAL.clicked.connect(self.dajedimincorsolovirtuale)
        self.pointing_optimization_shake1cb = QCheckBox('shake ccd1')
        self.pointing_optimization_shake1cb.clicked.connect(self.change_shake_ccd1_state)
        self.pointing_optimization_shake2cb = QCheckBox('shake ccd2')
        self.pointing_optimization_shake2cb.clicked.connect(self.change_shake_ccd2_state)
        self.pointing_optimization_shake1magR = QLineEdit()
        self.pointing_optimization_shake1magR.textEdited.connect(self.shake_ccd1_edit)
        self.pointing_optimization_shake2magR = QLineEdit()
        self.pointing_optimization_shake2magR.textEdited.connect(self.shake_ccd2_edit)
        self.pointing_optimization_shake1magW = QLineEdit()
        self.pointing_optimization_shake1magW.editingFinished.connect(self.shake_ccd1_edit_done)
        self.pointing_optimization_shake1magW.hide()
        self.pointing_optimization_shake2magW = QLineEdit()
        self.pointing_optimization_shake2magW.editingFinished.connect(self.shake_ccd2_edit_done)
        self.pointing_optimization_shake2magW.hide()
        self.pointing_optimization_shakestart = QPushButton('Start shake')
        self.pointing_optimization_shakestart.clicked.connect(self.shake_on)
        self.pointing_optimization_shakestop = QPushButton('Stop shake')
        self.pointing_optimization_shakestop.clicked.connect(self.shake_off)
        self.pointing_optimization_cormin1tasto = QPushButton('cor.min.1 ccd1 Hor')
        self.pointing_optimization_cormin1tasto.clicked.connect(self.lancia_opt1)
        self.pointing_optimization_cormin1state = LineEditRO()
        self.pointing_optimization_cormin1on = QPushButton('ON')
        self.pointing_optimization_cormin1on.clicked.connect(self.opt1on)
        self.pointing_optimization_cormin1sb = QPushButton('Standby')
        self.pointing_optimization_cormin1sb.clicked.connect(self.opt1sb)
        self.pointing_optimization_cormin2tasto = QPushButton('cor.min.2 ccd1 Ver')
        self.pointing_optimization_cormin2tasto.clicked.connect(self.lancia_opt2)
        self.pointing_optimization_cormin2state = LineEditRO()
        self.pointing_optimization_cormin2on = QPushButton('ON')
        self.pointing_optimization_cormin2on.clicked.connect(self.opt2on)
        self.pointing_optimization_cormin2sb = QPushButton('Standby')
        self.pointing_optimization_cormin2sb.clicked.connect(self.opt2sb)
        self.pointing_optimization_cormin3tasto = QPushButton('cor.min.3 ccd2 Hor')
        self.pointing_optimization_cormin3tasto.clicked.connect(self.lancia_opt3)
        self.pointing_optimization_cormin3state = LineEditRO()
        self.pointing_optimization_cormin3on = QPushButton('ON')
        self.pointing_optimization_cormin3on.clicked.connect(self.opt3on)
        self.pointing_optimization_cormin3sb = QPushButton('Standby')
        self.pointing_optimization_cormin3sb.clicked.connect(self.opt3sb)
        self.pointing_optimization_cormin4tasto = QPushButton('cor.min.4 ccd2 Ver')
        self.pointing_optimization_cormin4tasto.clicked.connect(self.lancia_opt4)
        self.pointing_optimization_cormin4state = LineEditRO()
        self.pointing_optimization_cormin4on = QPushButton('ON')
        self.pointing_optimization_cormin4on.clicked.connect(self.opt4on)
        self.pointing_optimization_cormin4sb = QPushButton('Standby')
        self.pointing_optimization_cormin4sb.clicked.connect(self.opt4sb)
        #
        self.pointing_feedback_state = QPushButton()
        self.pointing_feedback_state.clicked.connect(self.lancia_pannello_pointing_feedback)
        self.pointing_feedback_barra = QProgressBar()
        self.pointing_feedback_on = QPushButton('ON')
        self.pointing_feedback_on.clicked.connect(self.fbFEL_acceso)
        self.pointing_feedback_sb = QPushButton('Standby')
        self.pointing_feedback_sb.clicked.connect(self.fbFEL_standby)
        self.pointing_feedback_marker = QPushButton('marker OK')
        self.pointing_feedback_marker.clicked.connect(self.fbFEL_crocettalo)
        self.pointing_feedback_fbkeep_reference = QCheckBox('keep_reference')
        self.pointing_feedback_fbkeep_reference.clicked.connect(self.checkboxreference)
        self.pointing_feedback_gainslow = QPushButton('gain:SLOW')
        self.pointing_feedback_gainslow.clicked.connect(self.pointingfeedbackinslowgain)
        self.pointing_feedback_gainfast = QPushButton('gain:FAST')
        self.pointing_feedback_gainfast.clicked.connect(self.pointingfeedbackinfastgain)
        self.pointing_feedback_relaxstate = LineEditRO()
        self.pointing_feedback_relaxon = QPushButton('ON')
        self.pointing_feedback_relaxon.clicked.connect(self.relax_felfb)
        self.pointing_feedback_relaxsb = QPushButton('Standby')
        self.pointing_feedback_relaxsb.clicked.connect(self.unrelax_felfb)
        self.pointing_trajectory_save1 = QPushButton('Save memory1')
        self.pointing_trajectory_save1.clicked.connect(self.fbFEL_saveRef1)
        self.pointing_trajectory_restore1 = QPushButton('Restore memory1')
        self.pointing_trajectory_restore1.clicked.connect(self.fbFEL_restoreRef1)
        self.pointing_trajectory_save2 = QPushButton('Save memory2')
        self.pointing_trajectory_save2.clicked.connect(self.fbFEL_saveRef2)
        self.pointing_trajectory_restore2 = QPushButton('Restore memory2')
        self.pointing_trajectory_restore2.clicked.connect(self.fbFEL_restoreRef2)
        self.pointing_trajectory_h1 = LineEditRO()
        self.pointing_trajectory_v1 = LineEditRO()
        self.pointing_trajectory_h2 = LineEditRO()
        self.pointing_trajectory_v2 = LineEditRO()
        self.pointing_trajectory_selector = QPushButton('switch to 2d')  # switch to numeric
        # .clicked.connect(self.)
        self.pointing_trajectory_1su = QPushButton('UP')
        self.pointing_trajectory_1su.clicked.connect(self.fbFEL_retrV1more)
        self.pointing_trajectory_1sx = QPushButton('LEFT')
        self.pointing_trajectory_1sx.clicked.connect(self.fbFEL_retrH1less)
        self.pointing_trajectory_1dx = QPushButton('RIGHT')
        self.pointing_trajectory_1dx.clicked.connect(self.fbFEL_retrH1more)
        self.pointing_trajectory_1giu = QPushButton('DOWN')
        self.pointing_trajectory_1giu.clicked.connect(self.fbFEL_retrV1less)
        self.pointing_trajectory_1passo = QLineEdit()
        self.pointing_trajectory_2su = QPushButton('UP')
        self.pointing_trajectory_2su.clicked.connect(self.fbFEL_retrV2more)
        self.pointing_trajectory_2sx = QPushButton('LEFT')
        self.pointing_trajectory_2sx.clicked.connect(self.fbFEL_retrH2less)
        self.pointing_trajectory_2dx = QPushButton('RIGHT')
        self.pointing_trajectory_2dx.clicked.connect(self.fbFEL_retrH2more)
        self.pointing_trajectory_2giu = QPushButton('DOWN')
        self.pointing_trajectory_2giu.clicked.connect(self.fbFEL_retrV2less)
        self.pointing_trajectory_2passo = QLineEdit()
        self.pointing_alignment_autotool = QPushButton('Automatic Alignment tool with motors')
        self.pointing_alignment_autotool.clicked.connect(self.lancia_alignmenttool)
        self.pointing_alignment_autotool.setDisabled(1)
        self.pointing_alignment_manualtool = QPushButton('Manual Alignment tool with motors')
        self.pointing_alignment_manualtool.clicked.connect(self.lancia_alignmenttool)
        self.pointing_alignment_hdb = QPushButton('Recall values from HDB')
        self.pointing_alignment_hdb.clicked.connect(self.lancia_hdbtool)
        self.pointing_alignment_hdb.setDisabled(1)
        self.pointing_alignment_iris = QPushButton('iris')
        self.pointing_alignment_iris.clicked.connect(self.lancia_iride)
        self.pointing_alignment_ccd1 = QPushButton('1st feedback CCD')
        self.pointing_alignment_ccd1.clicked.connect(self.lancia_CCD1)
        self.pointing_alignment_ccd2 = QPushButton('2nd feedback CCD')
        self.pointing_alignment_ccd2.clicked.connect(self.lancia_CCD2)
        self.pointing_alignment_motor1 = QPushButton('1st alignment motor')
        self.pointing_alignment_motor1.clicked.connect(self.lancia_motor1)
        self.pointing_alignment_motor2 = QPushButton('2nd alignment motor')
        self.pointing_alignment_motor2.clicked.connect(self.lancia_motor2)
        self.pointing_alignment_piezo1 = QPushButton('1st feedback piezo')
        self.pointing_alignment_piezo1.clicked.connect(self.lancia_piezo1)
        self.pointing_alignment_piezo2 = QPushButton('2nd feedback piezo')
        self.pointing_alignment_piezo2.clicked.connect(self.lancia_piezo2)
        self.pointing_alignment_screen1 = QPushButton('screen sfel (1st)')
        self.pointing_alignment_screen1.clicked.connect(self.lancia_schermo1_schermo)
        self.pointing_alignment_ccdscreen1 = QPushButton('CCD sfel (1st)')
        self.pointing_alignment_ccdscreen1.clicked.connect(self.lancia_schermo1_ccd)
        self.pointing_alignment_screen1setlaser = QPushButton('adj.for laser')
        self.pointing_alignment_screen1setlaser.clicked.connect(self.schermo1attenuaperseed)
        self.pointing_alignment_screen1setebeam = QPushButton('adj.for ebeam')
        self.pointing_alignment_screen1setebeam.clicked.connect(self.schermo1attenuaperebeam)
        self.pointing_alignment_screen2 = QPushButton('screen fel (2nd)')
        self.pointing_alignment_screen2.clicked.connect(self.lancia_schermo2_schermo)
        self.pointing_alignment_ccdscreen2 = QPushButton('CCD fel (2nd)')
        self.pointing_alignment_ccdscreen2.clicked.connect(self.lancia_schermo2_ccd)
        self.pointing_alignment_screen2setlaser = QPushButton('adj.for laser')
        self.pointing_alignment_screen2setlaser.clicked.connect(self.schermo2attenuaperseed)
        self.pointing_alignment_screen2setebeam = QPushButton('adj.for ebeam')
        self.pointing_alignment_screen2setebeam.clicked.connect(self.schermo2attenuaperebeam)
        self.pointing_alignment_screen3 = QPushButton('screen iufel (3rd)')
        self.pointing_alignment_screen3.clicked.connect(self.lancia_schermo3_schermo)
        self.pointing_alignment_ccdscreen3 = QPushButton('CCD iufel (3rd)')
        self.pointing_alignment_ccdscreen3.clicked.connect(self.lancia_schermo3_ccd)
        self.pointing_alignment_screen3setlaser = QPushButton('adj.for laser')
        self.pointing_alignment_screen3setlaser.clicked.connect(self.schermo3attenuaperseed)
        self.pointing_alignment_screen3setebeam = QPushButton('adj.for ebeam')
        self.pointing_alignment_screen3setebeam.clicked.connect(self.schermo3attenuaperebeam)
        self.pointing_LO = QGridLayout()
        self.pointing_LO.addWidget(QLabel('Optimization: '), 10, 0)
        self.pointing_LO.addWidget(self.pointing_optimization_style, 10, 1, 1, 5)
        self.pointing_LO.addWidget(QLabel('Target: '), 11, 0)
        self.pointing_LO.addWidget(self.pointing_optimization_target, 11, 1, 1, 4)
        self.pointing_LO.addWidget(self.pointing_optimization_targetlist, 11, 1, 1, 4)
        self.pointing_LO.addWidget(self.pointing_optimization_targetchange, 11, 5)
        self.pointing_LO.addWidget(self.pointing_optimization_targetapply, 11, 5)
        
        self.pointing_LO.addWidget(self.pointing_optimization_off, 12, 0)
        self.pointing_LO.addWidget(self.pointing_optimization_off_l, 12, 1, 1, 3)
        self.pointing_LO.addWidget(self.pointing_optimization_standard, 13, 0)
        self.pointing_LO.addWidget(self.pointing_optimization_standard_l, 13, 1, 1, 3)
        self.pointing_LO.addWidget(self.pointing_optimization_infstandard, 14, 0)
        self.pointing_LO.addWidget(self.pointing_optimization_infstandard_l, 14, 1, 1, 3)
        self.pointing_LO.addWidget(self.pointing_optimization_infstandardshake, 15, 0)
        self.pointing_LO.addWidget(self.pointing_optimization_infstandardshake_l, 15, 1, 1, 3)
#        self.pointing_LO.addWidget(self.pointing_optimization_configstandardopt, 16, 0)
#        self.pointing_LO.addWidget(self.pointing_optimization_configstandardopt_l, 16, 1, 1, 3)
        self.pointing_LO.addWidget(self.pointing_optimization_shakeandcorrminALL, 17, 0)
        self.pointing_LO.addWidget(self.pointing_optimization_shakeandcorrminALL_l, 17, 1, 1, 3)
        self.pointing_LO.addWidget(self.pointing_optimization_shakeandcorrminVIRTUAL, 18, 0)
        self.pointing_LO.addWidget(self.pointing_optimization_shakeandcorrminVIRTUAL_l, 18, 1, 1, 3)
        self.pointing_LO.addWidget(self.pointing_optimization_corrminALL, 19, 0)
        self.pointing_LO.addWidget(self.pointing_optimization_corrminALL_l, 19, 1, 1, 3)
        self.pointing_LO.addWidget(self.pointing_optimization_corrminVIRTUAL, 20, 0)
        self.pointing_LO.addWidget(self.pointing_optimization_corrminVIRTUAL_l, 20, 1, 1, 3)

        self.pointing_LO.addWidget(self.pointing_optimization_shake1cb, 60, 0)
        self.pointing_LO.addWidget(self.pointing_optimization_shake1magW, 60, 1)
        self.pointing_LO.addWidget(self.pointing_optimization_shake1magR, 60, 1)
        self.pointing_LO.addWidget(self.pointing_optimization_shake2cb, 60, 2)
        self.pointing_LO.addWidget(self.pointing_optimization_shake2magW, 60, 3)
        self.pointing_LO.addWidget(self.pointing_optimization_shake2magR, 60, 3)
        self.pointing_LO.addWidget(self.pointing_optimization_shakestart, 60, 4)
        self.pointing_LO.addWidget(self.pointing_optimization_shakestop, 60, 5)

        self.pointing_LO.addWidget(self.pointing_optimization_cormin1tasto, 70, 0)
        self.pointing_LO.addWidget(self.pointing_optimization_cormin1state, 70, 1, 1, 3)
        self.pointing_LO.addWidget(self.pointing_optimization_cormin1on, 70, 4)
        self.pointing_LO.addWidget(self.pointing_optimization_cormin1sb, 70, 5)
        self.pointing_LO.addWidget(self.pointing_optimization_cormin2tasto, 71, 0)
        self.pointing_LO.addWidget(self.pointing_optimization_cormin2state, 71, 1, 1, 3)
        self.pointing_LO.addWidget(self.pointing_optimization_cormin2on, 71, 4)
        self.pointing_LO.addWidget(self.pointing_optimization_cormin2sb, 71, 5)
        self.pointing_LO.addWidget(self.pointing_optimization_cormin3tasto, 72, 0)
        self.pointing_LO.addWidget(self.pointing_optimization_cormin3state, 72, 1, 1, 3)
        self.pointing_LO.addWidget(self.pointing_optimization_cormin3on, 72, 4)
        self.pointing_LO.addWidget(self.pointing_optimization_cormin3sb, 72, 5)
        self.pointing_LO.addWidget(self.pointing_optimization_cormin4tasto, 73, 0)
        self.pointing_LO.addWidget(self.pointing_optimization_cormin4state, 73, 1, 1, 3)
        self.pointing_LO.addWidget(self.pointing_optimization_cormin4on, 73, 4)
        self.pointing_LO.addWidget(self.pointing_optimization_cormin4sb, 73, 5)

        self.pointing_LO.addWidget(QHLine(), 119, 0, 1, 6)
        self.pointing_LO.addWidget(self.pointing_feedback_state, 120, 0)
        self.pointing_LO.addWidget(self.pointing_feedback_barra, 120, 1)
        self.pointing_LO.addWidget(self.pointing_feedback_on, 120, 2)
        self.pointing_LO.addWidget(self.pointing_feedback_sb, 120, 3)
        self.pointing_LO.addWidget(self.pointing_feedback_marker, 120, 4)
        self.pointing_LO.addWidget(self.pointing_feedback_fbkeep_reference, 120, 5)
        self.pointing_LO.addWidget(self.pointing_feedback_gainslow, 121, 0)
        self.pointing_LO.addWidget(self.pointing_feedback_gainfast, 121, 1)
        self.pointing_LO.addWidget(self.pointing_feedback_relaxstate, 121, 3)
        self.pointing_LO.addWidget(self.pointing_feedback_relaxon, 121, 4)
        self.pointing_LO.addWidget(self.pointing_feedback_relaxsb, 121, 5)
        
        self.pointing_LO.addWidget(QLabel('Trajectory:'), 124, 0)
        self.pointing_LO.addWidget(self.pointing_trajectory_h1, 124, 1)
        self.pointing_LO.addWidget(self.pointing_trajectory_v1, 124, 2)
        self.pointing_LO.addWidget(self.pointing_trajectory_h2, 124, 3)
        self.pointing_LO.addWidget(self.pointing_trajectory_v2, 124, 4)
        
        self.pointing_LO.addWidget(self.pointing_trajectory_save1, 125, 0)
        self.pointing_LO.addWidget(self.pointing_trajectory_save2, 125, 1)
        self.pointing_LO.addWidget(self.pointing_trajectory_restore1, 125, 2)
        self.pointing_LO.addWidget(self.pointing_trajectory_restore2, 125, 3)
        
        self.pointing_LO.addWidget(QHLine(), 130, 0, 1, 6)
        self.pointing_LO.addWidget(QLabel('1st point'), 133, 0)
        self.pointing_LO.addWidget(self.pointing_trajectory_1su, 133, 1)
        self.pointing_LO.addWidget(self.pointing_trajectory_1sx, 134, 0)
        self.pointing_LO.addWidget(self.pointing_trajectory_1dx, 134, 2)
        self.pointing_LO.addWidget(self.pointing_trajectory_1giu, 135, 1)
        self.pointing_LO.addWidget(self.pointing_trajectory_1passo, 134, 1)
        self.pointing_LO.addWidget(QVLine(), 130, 3, 3, 1)
        self.pointing_LO.addWidget(QLabel('2nd point'), 133, 3)
        self.pointing_LO.addWidget(self.pointing_trajectory_2su, 133, 4)
        self.pointing_LO.addWidget(self.pointing_trajectory_2sx, 134, 3)
        self.pointing_LO.addWidget(self.pointing_trajectory_2dx, 134, 5)
        self.pointing_LO.addWidget(self.pointing_trajectory_2giu, 135, 4)
        self.pointing_LO.addWidget(self.pointing_trajectory_2passo, 134, 4)
        self.pointing_LO.addWidget(self.pointing_alignment_manualtool, 136, 0, 1, 2)
        self.pointing_LO.addWidget(self.pointing_alignment_autotool, 136, 2, 1, 2)
        self.pointing_LO.addWidget(self.pointing_alignment_hdb, 136, 4)
        self.pointing_LO.addWidget(self.pointing_alignment_iris, 136, 5)
        self.pointing_LO.addWidget(QHLine(), 140, 0, 1, 6)
        self.pointing_LO.addWidget(self.pointing_alignment_ccd1, 142, 0, 1, 2)
        self.pointing_LO.addWidget(self.pointing_alignment_motor1, 142, 2, 1, 2)
        self.pointing_LO.addWidget(self.pointing_alignment_piezo1, 142, 4, 1, 2)
        self.pointing_LO.addWidget(self.pointing_alignment_ccd2, 143, 0, 1, 2)
        self.pointing_LO.addWidget(self.pointing_alignment_motor2, 143, 2, 1, 2)
        self.pointing_LO.addWidget(self.pointing_alignment_piezo2, 143, 4, 1, 2)
        self.pointing_LO.addWidget(self.pointing_alignment_screen1, 144, 0, 1, 2)
        self.pointing_LO.addWidget(self.pointing_alignment_ccdscreen1, 144, 2, 1, 2)
        self.pointing_LO.addWidget(self.pointing_alignment_screen1setlaser, 144, 4)
        self.pointing_LO.addWidget(self.pointing_alignment_screen1setebeam, 144, 5)
        self.pointing_LO.addWidget(self.pointing_alignment_screen2, 145, 0, 1, 2)
        self.pointing_LO.addWidget(self.pointing_alignment_ccdscreen2, 145, 2, 1, 2)
        self.pointing_LO.addWidget(self.pointing_alignment_screen2setlaser, 145, 4)
        self.pointing_LO.addWidget(self.pointing_alignment_screen2setebeam, 145, 5)
        self.pointing_LO.addWidget(self.pointing_alignment_screen3, 146, 0, 1, 2)
        self.pointing_LO.addWidget(self.pointing_alignment_ccdscreen3, 146, 2, 1, 2)
        self.pointing_LO.addWidget(self.pointing_alignment_screen3setlaser, 146, 4)
        self.pointing_LO.addWidget(self.pointing_alignment_screen3setebeam, 146, 5)
        self.robaspaziale.setLayout(self.pointing_LO)
        globale = QGridLayout()
        globale.addWidget(self.titolo, 0, 0, 1, 1)
        globale.addWidget(self.contenitore, 1, 0, 1, 1)
        self.setLayout(globale)
        self.setStyleSheet("QDialog {background-color: rgb(210, 255, 255)}")
        self.setWindowTitle("SEED LASER (OPA)")
        self.show()
        # inizializzazione
        # target per pointing
        tmp = sacco['opti1'].GetTargets()
        for indice in range(len(tmp)):
            self.pointing_optimization_targetlist.addItem(tmp[indice])
        self.pointing_optimization_target.setText(sacco['opti1'].TargetName)
        # target per tempo
        tmp = sacco['opti0'].GetTargets()
        for indice in range(len(tmp)):
            self.timing_targetlist.addItem(tmp[indice])
        self.timing_target.setText(sacco['opti0'].TargetName)
        # limiti energy feedback
        if chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F1O':
            self.energy_barra.setRange(0, 100)
            self.energy_feedback_setvalue.setValue(sacco['fbenergy'].SensorReferenceValues)
        elif chevergognafarloamano == 'F2T' or chevergognafarloamano == 'F1T':
            self.energy_attenuator_setvalue.setValue(sacco['attenuator'].Position)
        # delay line
        self.timing_trls4_setposition.setValue(sacco['trls4'].Position[0])
        self.timing_trls8_setposition.setValue(sacco['trls8'].Position[0])
        # timer
        self.timer = QBasicTimer()
        self.timer.start(2000, self)

    def timerEvent(self, event):
        self.update()

    def __del__(self):
        self.timer.stop()

    def update(self):
        tempo0 = time.time()
        self.casellamessaggi.clear()
        if chiaccherone > 0:
            print(' ')
            print(' ')
    # tutto shutter e attenuatore
        try:
            tmp = sacco['mpsshutter'].read_attributes(['State', 'AbiGroup'])
            shutter_state = str(tmp[0].value)
            if False in tmp[1].value:
                shutter_abi = 'Disabled'
            elif False not in tmp[1].value:
                shutter_abi = 'Enable'
            else:
                shutter_abi = '#####'
        except:
            shutter_state = '#####'
            shutter_abi = '#####'
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['mpsshutter']) + ' is not answering!!')
        if chiaccherone > 0:
            print('shutter ' + str(shutter_state) + ', ' + str(shutter_abi))
        try:
            tmp = sacco['mpsattenuator'].read_attribute('StatAtt')
            mpsattenuator_in = tmp.value[0]
            mpsattenuator_out = tmp.value[1]
            mpsattenuator_abi = tmp.value[2]
        except:
            mpsattenuator_in = '#####'
            mpsattenuator_out = '#####'
            mpsattenuator_abi = '#####'
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['mpsattenuator']) + ' is not answering!!')
        if chiaccherone > 0:
            print('attenuator ' + str(mpsattenuator_in) + ', ' + str(mpsattenuator_out) + ', ' + str(mpsattenuator_abi))
        if mpsattenuator_abi:
            attenuator_abi = 'Enable'
        else:
            attenuator_abi = 'Disable'
        if mpsattenuator_in == True:
            attenuator_state = 'INSERTED'
        elif mpsattenuator_out == True:
            attenuator_state = 'EXTRACTED'
        else:
            attenuator_state = '#####'
        capostringa = 'Shutter: ' + str(shutter_state) + '/' + shutter_abi + ', Attenuator: ' + attenuator_state + '/' + attenuator_abi
        self.contenitore.setItemText(1, capostringa)
    # tutto energia
        try:
            energy_uv = round(sacco['emcalib'].Energy, 3)
        except:
            energy_uv = '#####'
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['emcalib']) + ' is not answering!!')
        if chiaccherone > 0:
            print('emcalib: ' + str(energy_uv))
        try:
            energy_std = round(sacco['emuv'].EnergyStd, 1)
        except:
            energy_std = '#####'
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['emuv']) + ' is not answering!!')
        if chiaccherone > 0:
            print('emuv: ' + str(energy_std))
        try:
            att_pos = round(sacco['attenuator'].Position, 1)
        except:
            att_pos = 0
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['attenuator']) + ' is not answering!!')
        if chiaccherone > 0:
            print('att_pos: ' + str(att_pos))
        self.energy_attenuator_setvalue.setValue(att_pos)
        if chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F1O':
            try:
                tmp = sacco['fbenergy'].read_attributes(['State', 'ActuatorMaxValues', 'ActuatorMinValues'])
                energy_fb = str(tmp[0].value)
                fbbarrabasso = tmp[2].value[0]
                fbbarraalto = tmp[1].value[0]
            except:
                energy_fb = '#####'
                fbbarrabasso = '#####'
                fbbarraalto = '#####'
                self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['fbenergy']) + ' is not answering!!')
            if chiaccherone > 0:
                print('fbenergy: ' + energy_fb + ', ' + str(fbbarrabasso) + ', ' + str(fbbarraalto))
            if energy_fb == 'ON':
                self.energy_attenuator_tasto.setDisabled(True)
                self.energy_attenuator_setvalue.setDisabled(True)
                self.energy_attenuator_set.setDisabled(True)
            else:
                self.energy_attenuator_tasto.setDisabled(False)
                self.energy_attenuator_setvalue.setDisabled(False)
                self.energy_attenuator_set.setDisabled(False)
            percentoenergy = 100*(att_pos - fbbarrabasso)/(fbbarraalto - fbbarrabasso)
            self.energy_barra.setValue(percentoenergy)
        else:
            energy_fb = 'no feedback'
        capostringa = 'Energy: ' + str(energy_uv) + 'uJ, std: ' + str(energy_std) + '%, feedback: ' + str(energy_fb) + ', attenuator: ' + str(att_pos)
        self.contenitore.setItemText(2, capostringa)
   # tutto lambda
        self.wavelenght_subp.clear()
        try:
            tmp = sacco['sptcm'].read_attributes(['GaussFitCenter', 'GaussFitWidth'])
            wl_centro = str(round(tmp[0].value, 2))
            wl_banda = str(round(tmp[1].value, 2))
        except:
            wl_centro = '#####'
            wl_banda = '#####'
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['sptcm']) + ' is not gaussianfitting!!')
        try:
            tmp = sacco['sptcm'].read_attributes(['Lambda', 'Wave'])
            wl_x = tmp[0].value
            wl_y = tmp[1].value
        except:
            wl_x = [0]
            wl_y = [0]
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['sptcm']) + ' is not answering!!')
        if chiaccherone > 0:
            print('sptcm ' + wl_centro + ', ' + wl_banda + ', ' + str(len(wl_x)) + ', ' + str(len(wl_y)))
        capostringa = 'Wavelenght: ' + str(wl_centro) + 'nm, bwd: ' + str(wl_banda) + 'nm'
        self.contenitore.setItemText(3, capostringa)
        self.wavelenght_subp.plot(wl_x, wl_y, '-')
        self.wavelenght_subp.grid(True)
        self.wavelenght_figura.tight_layout(pad=0.1, w_pad=0.1, h_pad=0.1)
        self.wavelenght_canvas.draw()
        if chevergognafarloamano == 'F2T' or chevergognafarloamano == 'F1T':
            try:
                xtalthgpos = str(sacco['thgxtal'].read_attribute('Position').value)
            except:
                xtalthgpos = '####'
                self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['thgxtal']) + ' is not answering!!')
            if chiaccherone > 0:
                print('thgxtal ' + xtalthgpos)
            self.wavelenght_read.setText(str(xtalthgpos))
    # tutto timing
        try:
            tmp = sacco['opti0'].read_attributes(['State', 'Correlation', 'TargetName'])
            opti0_state = str(tmp[0].value)
            opti0_correlazio = str(round(tmp[1].value, 3))
            opti0_target = tmp[2].value
        except:
            opti0_state = '#####'
            opti0_correlazio = '#####'
            opti0_target = '#####'
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['opti0']) + ' is not answering!!')
        if chiaccherone > 0:
            print('opti0 ' + str(opti0_state) + ', ' + str(opti0_correlazio) + ', ' + str(opti0_target))
        self.timing_target.setText(opti0_target)
        self.timing_corrmin_state.setText(opti0_state + ', corr: ' + opti0_correlazio)
        try:
            listafastscan = sacco['fastdelayscan'].GetSensorDeviceNames()
            pesifastscan = sacco['fastdelayscan'].SensorWeights
        except:
            listafastscan = []
            pesifastscan = []
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['fastdelayscan']) + ' is not answering!!')
        if chiaccherone > 0:
            print('fastdelayscan ' + str(len(listafastscan)) + ', ' + str(len(pesifastscan.nonzero())))
        try:
            if pesifastscan[listafastscan.index(opti0_target)] == 1:
                self.timing_target.setStyleSheet("background-color: #00ff00")
            else:
                self.timing_target.setStyleSheet("background-color: #ffff00")
                self.casellamessaggi.insertItem(0, '!!Warning: targets for corr.min.delay and fast delay scan are not aligned!!')
        except:
            self.timing_target.setStyleSheet("background-color: #ff0000")
        try:
            tmp = sacco['trls4'].read_attributes(['Position', 'Speed'])
            pos_trls4 = str(round(tmp[0].value[0], 3))
            vel_trls4 = str(round(tmp[1].value[0], 0))
        except:
            pos_trls4 = '#####'
            vel_trls4 = '#####'
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['trls4']) + ' is not answering!!')
        if chiaccherone > 0:
            print('trls4 ' + pos_trls4 + ', ' + vel_trls4)
        self.timing_trls4_readposition.setText(pos_trls4)
        self.timing_trls4_speedread.setText(vel_trls4)
        try:
            tmp = sacco['trls8'].read_attributes(['Position', 'Speed'])
            pos_trls8 = str(round(tmp[0].value[0], 3))
            vel_trls8 = str(round(tmp[1].value[0], 0))
        except:
            pos_trls8 = '#####'
            vel_trls8 = '#####'
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['trls8']) + ' is not answering!!')
        if chiaccherone > 0:
            print('trls8 ' + pos_trls8 + ', ' + vel_trls8)
        self.timing_trls8_readposition.setText(pos_trls8)
        self.timing_trls8_speedread.setText(vel_trls8)
        if opti0_state != 'ON':
            capostringa = 'Timing: trls4 pos ' + str(pos_trls4) + 'ps, trls4 pos ' + str(pos_trls8) + 'ps'
        else:
            capostringa = 'Timing: correlation minimizer ON. trls4 pos ' + pos_trls4 + ', trls8 pos ' + pos_trls8
        self.contenitore.setItemText(4, capostringa)
    # tutto pointing
        try:
            tmp = sacco['opti1'].read_attributes(['State', 'Correlation', 'TargetName'])
            opti1_state = str(tmp[0].value)
            opti1_correlazio = str(round(tmp[1].value, 3))
            opti1_target = tmp[2].value
        except:
            opti1_state = '#####'
            opti1_correlazio = '#####'
            opti1_target = '#####'
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['opti1']) + ' is not answering!!')
        if chiaccherone > 0:
            print('opti1 ' + str(opti1_state) + ', ' + str(opti1_correlazio) + ', ' + str(opti1_target))
        self.pointing_optimization_cormin1state.setText(str(opti1_state) + ', corr: ' + str(opti1_correlazio))
        if str(opti1_state) == 'ON':
            self.pointing_optimization_cormin1state.setStyleSheet("background-color: #00ff00")
        elif str(opti1_state) == 'OFF':
            self.pointing_optimization_cormin1state.setStyleSheet("background-color: #ffffff")
        elif str(opti1_state) == 'ALARM':
            self.pointing_optimization_cormin1state.setStyleSheet("background-color: #ffff00")
        elif str(opti1_state) == 'FAULT':
            self.pointing_optimization_cormin1state.setStyleSheet("background-color: #ff0000")
        else:
            self.pointing_optimization_cormin1state.setStyleSheet("background-color: rgb(200, 200, 200)")
        try:
            tmp = sacco['opti2'].read_attributes(['State', 'Correlation', 'TargetName'])
            opti2_state = str(tmp[0].value)
            opti2_correlazio = str(round(tmp[1].value, 3))
            opti2_target = tmp[2].value
        except:
            opti2_state = '#####'
            opti2_correlazio = '#####'
            opti2_target = '#####'
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['opti2']) + ' is not answering!!')
        if chiaccherone > 0:
            print('opti2 ' + str(opti2_state) + ', ' + str(opti2_correlazio) + ', ' + str(opti2_target))
        self.pointing_optimization_cormin2state.setText(str(opti2_state) + ', corr: ' + str(opti2_correlazio))
        if str(opti2_state) == 'ON':
            self.pointing_optimization_cormin2state.setStyleSheet("background-color: #00ff00")
        elif str(opti2_state) == 'OFF':
            self.pointing_optimization_cormin2state.setStyleSheet("background-color: #ffffff")
        elif str(opti2_state) == 'ALARM':
            self.pointing_optimization_cormin2state.setStyleSheet("background-color: #ffff00")
        elif str(opti2_state) == 'FAULT':
            self.pointing_optimization_cormin2state.setStyleSheet("background-color: #ff0000")
        else:
            self.pointing_optimization_cormin2state.setStyleSheet("background-color: rgb(200, 200, 200)")
        try:
            tmp = sacco['opti3'].read_attributes(['State', 'Correlation', 'TargetName'])
            opti3_state = str(tmp[0].value)
            opti3_correlazio = str(round(tmp[1].value, 3))
            opti3_target = tmp[2].value
        except:
            opti3_state = '#####'
            opti3_correlazio = '#####'
            opti3_target = '#####'
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['opti3']) + ' is not answering!!')
        if chiaccherone > 0:
            print('opti3 ' + str(opti3_state) + ', ' + str(opti3_correlazio) + ', ' + str(opti3_target))
        self.pointing_optimization_cormin3state.setText(str(opti3_state) + ', corr: ' + str(opti3_correlazio))
        if str(opti3_state) == 'ON':
            self.pointing_optimization_cormin3state.setStyleSheet("background-color: #00ff00")
        elif str(opti3_state) == 'OFF':
            self.pointing_optimization_cormin3state.setStyleSheet("background-color: #ffffff")
        elif str(opti3_state) == 'ALARM':
            self.pointing_optimization_cormin3state.setStyleSheet("background-color: #ffff00")
        elif str(opti3_state) == 'FAULT':
            self.pointing_optimization_cormin3state.setStyleSheet("background-color: #ff0000")
        else:
            self.pointing_optimization_cormin3state.setStyleSheet("background-color: rgb(200, 200, 200)")
        try:
            tmp = sacco['opti4'].read_attributes(['State', 'Correlation', 'TargetName'])
            opti4_state = str(tmp[0].value)
            opti4_correlazio = str(round(tmp[1].value, 3))
            opti4_target = tmp[2].value
        except:
            opti4_state = '#####'
            opti4_correlazio = '#####'
            opti4_target = '#####'
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['opti4']) + ' is not answering!!')
        if chiaccherone > 0:
            print('opti4 ' + str(opti4_state) + ', ' + str(opti4_correlazio) + ', ' + str(opti4_target))
        self.pointing_optimization_cormin4state.setText(str(opti4_state) + ', corr: ' + str(opti4_correlazio))
        if str(opti4_state) == 'ON':
            self.pointing_optimization_cormin4state.setStyleSheet("background-color: #00ff00")
        elif str(opti4_state) == 'OFF':
            self.pointing_optimization_cormin4state.setStyleSheet("background-color: #ffffff")
        elif str(opti4_state) == 'ALARM':
            self.pointing_optimization_cormin4state.setStyleSheet("background-color: #ffff00")
        elif str(opti4_state) == 'FAULT':
            self.pointing_optimization_cormin4state.setStyleSheet("background-color: #ff0000")
        else:
            self.pointing_optimization_cormin4state.setStyleSheet("background-color: rgb(200, 200, 200)")
        try:
            tmp = sacco['felfb'].read_attributes(['State', 'CorHorMax', 'CorVerMax', 'RefTrajHor', 'RefTrajVer', 'OptimizeState', 'OptimizeCountdown', 'KeepReferenceOn', 'OptimizeContinuous', 'OptimizeGain', 'OptimizeTargets', 'PIDparam'])
            stato_felfb = str(tmp[0].value)
            maxh_felfb = tmp[1].value
            maxv_felfb = tmp[2].value
            refh1_felfb = str(round(tmp[3].value[0], 3))
            refh2_felfb = str(round(tmp[3].value[1], 3))
            refv1_felfb = str(round(tmp[4].value[0], 3))
            refv2_felfb = str(round(tmp[4].value[1], 3))
            FBoptSTATE = tmp[5].value #
            FBoptTIME = tmp[6].value #
            fbkeep_ref = tmp[7].value
            fbOptContinuous = tmp[8].value #
            fbOptGain = tmp[9].value
            fbOptTarget = tmp[10].value.replace('1;0;', '')
            guadagni = tmp[11].value
        except:
            stato_felfb = 'NOT RESPONDING'
            maxh_felfb = '#####'
            maxv_felfb = '#####'
            refh1_felfb = '#####'
            refh2_felfb = '#####'
            refv1_felfb = '#####'
            refv2_felfb = '#####'
            FBoptSTATE = '#####'
            FBoptTIME = '#####'
            fbkeep_ref = '#####'
            fbOptContinuous = '#####'
            fbOptGain = '#####'
            fbOptTarget = '#####'
            guadagni = '#####'
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['felfb']) + ' is not answering!!')
        if chiaccherone > 0:
            print('felfb ' + stato_felfb + ', ' + str(maxh_felfb) + ', ' + str(maxv_felfb) + ', ' + refh1_felfb + ', ' + refh2_felfb + ', ' + refv1_felfb + ', ' + refv2_felfb + ', ' + str(FBoptSTATE) + ', ' + str(FBoptTIME) + ', ' + str(fbkeep_ref) + ', ' + str(fbOptContinuous) + ', ' + str(fbOptGain) + ', ' + str(fbOptTarget) + ', ' + str(guadagni))
        self.pointing_feedback_state.setText('Feedback is ' + stato_felfb)
        if stato_felfb == 'ON':
            self.pointing_feedback_state.setStyleSheet("background-color: #00ff00")
        elif stato_felfb == 'FAULT':
            self.pointing_feedback_state.setStyleSheet("background-color: #ff0000")
        else:
            self.pointing_feedback_state.setStyleSheet("background-color: rgb(200, 200, 200)")
        self.pointing_feedback_barra.setValue(np.amax([maxh_felfb, maxv_felfb, 0.0]))
        self.pointing_feedback_fbkeep_reference.setChecked(fbkeep_ref)
        self.pointing_trajectory_h1.setText('Hor1: ' + refh1_felfb + ' mm')
        self.pointing_trajectory_v1.setText('Ver1: ' + refv1_felfb + ' mm')
        self.pointing_trajectory_h2.setText('Hor2: ' + refh2_felfb + ' mm')
        self.pointing_trajectory_v2.setText('Ver2: ' + refv2_felfb + ' mm')
        if guadagni[1] < 0.01:
            self.pointing_feedback_gainslow.setStyleSheet("background-color: rgb(0, 255, 0)")
            self.pointing_feedback_gainfast.setStyleSheet("background-color: light gray")
        else:
            self.pointing_feedback_gainslow.setStyleSheet("background-color: light gray")
            self.pointing_feedback_gainfast.setStyleSheet("background-color: rgb(0, 255, 0)")
        try:
            stato_relax = str(sacco['relaxfelfb'].command_inout('State'))
        except:
            stato_relax = 'UNKNOWN'
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['relaxfelfb']) + ' is not answering!!')
        if chiaccherone > 0:
            print('relaxfelfb ' + stato_relax)
        self.pointing_feedback_relaxstate.setText('Relax is ' + str(sacco['felfbrelax'].State()))
        if stato_relax == 'ON':
            self.pointing_feedback_relaxstate.setStyleSheet("background-color: #00ff00")
        else:
            self.pointing_feedback_relaxstate.setStyleSheet("background-color: rgb(200, 200, 200)")
        try:
            tmp = sacco['ccd1'].read_attributes(['HorPosRelative', 'VerPosRelative'])
            pos_h_ccd1 = abs(tmp[0].value)
            pos_v_ccd1 = abs(tmp[1].value)
        except:
            pos_h_ccd1 = 1
            pos_v_ccd1 = 1
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['ccd1']) + ' is not answering!!')
        if chiaccherone > 0:
            print('ccd1 ' + str(pos_h_ccd1) + ', ' + str(pos_v_ccd1))
        try:
            tmp = sacco['ccd2'].read_attributes(['HorPosRelative', 'VerPosRelative'])
            pos_h_ccd2 = abs(tmp[0].value)
            pos_v_ccd2 = abs(tmp[1].value)
        except:
            pos_h_ccd2 = 1
            pos_v_ccd2 = 1
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['ccd2']) + ' is not answering!!')
        if chiaccherone > 0:
            print('ccd2 ' + str(pos_h_ccd2) + ', ' + str(pos_v_ccd2))
        if pos_h_ccd1 > 0.2 or pos_v_ccd1 > 0.2 or pos_h_ccd2 > 0.2 or pos_v_ccd2 > 0.2:
            self.pointing_feedback_marker.setStyleSheet("background-color: rgb(255, 0, 0)")
            self.pointing_feedback_marker.setText('Update marker')
        else:
            self.pointing_feedback_marker.setStyleSheet("background-color: rgb(0, 255, 0)")
            self.pointing_feedback_marker.setText('marker OK')
        try:
            tmp = sacco['parametrisalvati'].read_attribute('fb_fel_traj1').time.todatetime()
            self.pointing_trajectory_restore1.setText('Restore ' + str(tmp.year) + '/' + str(tmp.month) + '/' + str(tmp.day) + ' ' + str(tmp.hour) + ':' + str(tmp.minute))
            tmp = sacco['parametrisalvati'].read_attribute('fb_fel_traj2').time.todatetime()
            self.pointing_trajectory_restore2.setText('Restore ' + str(tmp.year) + '/' + str(tmp.month) + '/' + str(tmp.day) + ' ' + str(tmp.hour) + ':' + str(tmp.minute))
        except:
            self.pointing_trajectory_restore2.setText('Restore #####')
            self.pointing_trajectory_restore1.setText('Restore #####')
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['parametrisalvati']) + ' is not answering!!')
        try:
            tmp = sacco['parametrisalvati'].read_attributes(['fel_fb_contshake_ampl_ccd1', 'fel_fb_contshake_ampl_ccd2', 'fel_fb_contshake_ccd1', 'fel_fb_contshake_ccd2'])
            shake1 = str(tmp[0].value)
            shake2 = str(tmp[1].value)
            self.pointing_optimization_shake1cb.setChecked(tmp[2].value)
            self.pointing_optimization_shake2cb.setChecked(tmp[3].value)
            if self.pointing_optimization_shake1magR.text() != shake1:
                self.pointing_optimization_shake1magR.setText(shake1)
            if self.pointing_optimization_shake2magR.text() != shake2:
                self.pointing_optimization_shake2magR.setText(shake2)
        except:
            self.pointing_optimization_shake1magR.setText('#####')
            self.pointing_optimization_shake2magR.setText('#####')
            self.pointing_optimization_shake1cb.setChecked(0)
            self.pointing_optimization_shake2cb.setChecked(0)
            self.casellamessaggi.insertItem(0, '!!Alarm: ' + str(sacco['parametrisalvati']) + ' is not answering!!')
        if chiaccherone > 0:
            print('parametrisalvati ' + str(shake1) + ', ' + str(shake2) + ', ' + str(tmp[2].value) + ', ' + str(tmp[3].value))
        
        try:
            tmp0 = sacco['felfb'].command_inout('ScanGetParameters', 0)
            tmp1 = sacco['felfb'].command_inout('ScanGetParameters', 1)
        except:
            tmp0 = 0
            tmp1 = 0
        if abs(tmp0[0]) > 1e-4 and abs(tmp0[1]) > 1e-4 and FBoptSTATE == 2:
            self.pointing_optimization_shake1magR.setStyleSheet("background-color: rgb(0, 255, 0)")
            self.pointing_optimization_shake1cb.setStyleSheet("background-color: rgb(0, 255, 0)")
        else:
            self.pointing_optimization_shake1magR.setStyleSheet("background-color: rgb(255, 255, 255)")
            self.pointing_optimization_shake1cb.setStyleSheet("background-color: rgb(255, 255, 255)")
        if abs(tmp1[0]) > 1e-4 and abs(tmp1[1]) > 1e-4 and FBoptSTATE == 2:
            self.pointing_optimization_shake2magR.setStyleSheet("background-color: rgb(0, 255, 0)")
            self.pointing_optimization_shake2cb.setStyleSheet("background-color: rgb(0, 255, 0)")
        else:
            self.pointing_optimization_shake2magR.setStyleSheet("background-color: rgb(255, 255, 255)")
            self.pointing_optimization_shake2cb.setStyleSheet("background-color: rgb(255, 255, 255)")
        targetpool = [opti1_target, opti2_target, opti3_target, opti4_target, fbOptTarget]
        if opti1_target == opti2_target == opti3_target == opti4_target == fbOptTarget:
            self.pointing_optimization_target.setText(opti1_target)
            self.pointing_optimization_target.setStyleSheet("background-color: #00ff00")
        else:
            self.pointing_optimization_target.setText('!!one or more does not use ' + max(set(targetpool), key=targetpool.count) + ' as target')
            self.pointing_optimization_target.setStyleSheet("background-color: #00ff00")
        # riconoscimento stato ottimizzazione
        c1 = FBoptSTATE == 2
        c2 = fbOptContinuous
        c3 = fbOptGain != 0.0
        c4 = opti1_state == 'ON' and opti2_state == 'ON'
        c5 = opti3_state == 'ON' and opti4_state == 'ON'
        if not c1 and not c4 and not c5: #tutto spento
            self.pointing_optimization_style.setText('No optimization')
            self.pointing_optimization_style.setStyleSheet("background-color: rgb(255, 255, 255)")
            capostringa = 'Pointing: NO optimization, Hor1 ' + refh1_felfb + ', Ver1 ' + refv1_felfb + ', Hor2 ' + refh2_felfb + ', Ver2 ' + refv2_felfb
        elif not c1 and c4 and c5:  # shake
            self.pointing_optimization_style.setText('correlation minimizer on ccd1 and ccd2, no shake')
            self.pointing_optimization_style.setStyleSheet("background-color: rgb(0, 255, 0)")
            capostringa = 'Pointing: Optimization ON (corr.min.), Hor1 ' + refh1_felfb + ', Ver1 ' + refv1_felfb + ', Hor2 ' + refh2_felfb + ', Ver2 ' + refv2_felfb
        elif not c1 and not c4 and c5:  # shake
            self.pointing_optimization_style.setText('correlation minimizer only on ccd2, no shake')
            self.pointing_optimization_style.setStyleSheet("background-color: rgb(0, 255, 0)")
            capostringa = 'Pointing: Optimization ON (corr.min.ccd2), Hor1 ' + refh1_felfb + ', Ver1 ' + refv1_felfb + ', Hor2 ' + refh2_felfb + ', Ver2 ' + refv2_felfb
        elif c1 and not c2 and c3:  # std
            self.pointing_optimization_style.setText('Standard feedback optimization, countdown:' + str(FBoptTIME))
            self.pointing_optimization_style.setStyleSheet("background-color: rgb(0, 255, 0)")
            capostringa = 'Pointing: Optimization ON (Standard, countdown:' + str(FBoptTIME) + ' ), Hor1 ' + refh1_felfb + ', Ver1 ' + refv1_felfb + ', Hor2 ' + refh2_felfb + ', Ver2 ' + refv2_felfb
        elif c1 and c2 and c3 and not c4 and not c5:  # std inf
            self.pointing_optimization_style.setText('Infinite Standard feedback optimization')
            self.pointing_optimization_style.setStyleSheet("background-color: rgb(0, 255, 0)")
            capostringa = 'Pointing: Optimization ON (Standard infinite), Hor1 ' + refh1_felfb + ', Ver1 ' + refv1_felfb + ', Hor2 ' + refh2_felfb + ', Ver2 ' + refv2_felfb
        elif c1 and c2 and not c3 and c4 and c5:  # shake
            self.pointing_optimization_style.setText('Shake and correlation minimizer on ccd1 and ccd2')
            self.pointing_optimization_style.setStyleSheet("background-color: rgb(0, 255, 0)")
            capostringa = 'Pointing: Optimization ON (shake+corr.min.), Hor1 ' + refh1_felfb + ', Ver1 ' + refv1_felfb + ', Hor2 ' + refh2_felfb + ', Ver2 ' + refv2_felfb
        elif c1 and c2 and not c3 and not c4 and c5:  # shake
            self.pointing_optimization_style.setText('Shake and correlation minimizer only on ccd2')
            self.pointing_optimization_style.setStyleSheet("background-color: rgb(0, 255, 0)")
            capostringa = 'Pointing: Optimization ON (shake+corr.min.ccd2), Hor1 ' + refh1_felfb + ', Ver1 ' + refv1_felfb + ', Hor2 ' + refh2_felfb + ', Ver2 ' + refv2_felfb
        else:
            self.pointing_optimization_style.setText('!!ANOMALOUS optimizer configuration!!')
            self.pointing_optimization_style.setStyleSheet("background-color: rgb(255, 255, 0)")
            capostringa = 'Pointing: Optimization ON (ANOMALOUS settings), Hor1 ' + refh1_felfb + ', Ver1 ' + refv1_felfb + ', Hor2 ' + refh2_felfb + ', Ver2 ' + refv2_felfb
        self.contenitore.setItemText(5, capostringa)

# funzioni - shutter
    def mpsshutin(self):
        print('a')
        sacco['mpsshutter'].command_inout('close')

    def mpsshutout(self):
        print('a')
        sacco['mpsshutter'].command_inout('open')

    def mpsattin(self):
        print('a')
        sacco['mpsattenuator'].command_inout('insertatt')

    def mpsattout(self):
        print('a')
        sacco['mpsattenuator'].command_inout('removeatt')

# funzioni - energy
    def change_energy(self):
        gol = self.energy_feedback_setvalue.value()
        self.energy_barra.setValue(gol)
        sacco['fbenergy'].write_attribute('SensorReferenceValues', [gol])

    def change_attenuator(self):
        gol = self.energy_attenuator_setvalue.value()
        self.energy_barra.setValue(gol)
        sacco['attenuator'].write_attribute('Position', gol)

    def feedback_energia_smart_on(self):
        riferimento = sacco['emcalib'].Energy
        sacco['fbenergy'].write_attribute('SensorReferenceValues', [riferimento])
        sacco['fbenergy'].command_inout('On')

    def feedback_energia_sb(self):
        sacco['fbenergy'].command_inout('Standby')

    def lancia_pannello_energyfeedback(self):
        os.system('/runtime/bin/mimofb sl/feedback/fb_opa_energy_fel02.01 &')

    def lancia_pannello_attenuatore(self):
        if chevergognafarloamano == 'F2O':
            os.system('/runtime/bin/standa8smc1_basic sl/motor/rots_sl.16 -e -title Attenuator_UV-OPA2_"rots_sl.16" &')
        elif chevergognafarloamano == 'F2T':
            os.system('/runtime/bin/galilaxis sl/motor/rots_sl.09 -title SL_THG2_Attenuator_"rots_sl.09" &')
        elif chevergognafarloamano == 'F1T':
            os.system('/runtime/bin/galilaxis sl/motor/rots_sl.01 -e -title Attenuator_UV-THG_"rots_sl.01" &')
        elif chevergognafarloamano == 'F1O':
            os.system('/runtime/bin/standa8smc1_basic sl/motor/rots_sl.14 -e -title Attenuator_UV-OPA1_"rots_sl.14" &')


# funzioni - wavelenght
    def setopa(self):
        self.msgBox = QMessageBox()
        self.msgBox.setIcon(QMessageBox.Question)
        self.msgBox.setStandardButtons(QMessageBox.Ok | QMessageBox.Cancel)
        self.msgBox.setText("OPA wavelength should be changed only with SUPERGAP because it handle also feedbacks. Are you sure you want to proceed?")
        risp = self.msgBox.exec_()
        if risp == 1024:
            limiti = sacco['opa'].WavelengthRange
            gol = float(self.wavelenght_set.text())
            if gol >= limiti[0] and gol <= limiti[1]:
                sacco['opa'].write_attribute('Wavelength', gol)
            else:
                self.msgBox = QMessageBox()
                self.msgBox.setIcon(QMessageBox.Question)
                self.msgBox.setStandardButtons(QMessageBox.Ok | QMessageBox.Cancel)
                self.msgBox.setText('Opa wavelength range is ' + str(limiti[0]) + 'nm - ' + str(limiti[1]) + 'nm')
                self.msgBox.exec_()

    def thgxtaup(self):
        gol = float(self.wavelenght_step.text())
        previsione = sacco['thgxtal'].Position + float(self.wavelenght_step.text())
        if previsione > 109.5 and previsione < 111.3:
            sacco['thgxtal'].command_inout('GoToRelativePosition', gol)
        else:
            self.msgBox = QMessageBox()
            self.msgBox.setIcon(QMessageBox.Question)
            self.msgBox.setStandardButtons(QMessageBox.Ok | QMessageBox.Cancel)
            self.msgBox.setText("to prevent misalignment the position of the motor is limited to 109.5-111.3 deg")
            risp = self.msgBox.exec_()

    def thgxtadown(self):
        gol = -1*float(self.wavelenght_step.text())
        previsione = sacco['thgxtal'].Position - float(self.wavelenght_step.text())
        if previsione > 109.5 and previsione < 111.3:
            sacco['thgxtal'].command_inout('GoToRelativePosition', gol)
        else:
            self.msgBox = QMessageBox()
            self.msgBox.setIcon(QMessageBox.Question)
            self.msgBox.setStandardButtons(QMessageBox.Ok | QMessageBox.Cancel)
            self.msgBox.setText("to prevent misalignment the position of the motor is limited to 109.5-111.3 deg")
            risp = self.msgBox.exec_()

# funzioni - timing
    def campi_target_timing(self):
        self.timing_target.hide()
        self.timing_targetlist.show()
        self.timing_targetconfig.hide()
        self.timing_targetapply.show()

    def cambio_target_timing(self):
        # set target nuovo
        print(self.timing_targetlist.currentText())
        print(type(self.timing_targetlist.currentText()))
        sacco['opti0'].write_attribute('TargetName', str(self.timing_targetlist.currentText()))
        self.timing_target.show()
        self.timing_targetlist.hide()
        self.timing_targetconfig.show()
        self.timing_targetapply.hide()

    def lancia_optdelay(self):
        os.system('/runtime/bin/correlation_minimizer f/optimization/optimizer_sldelay_f.01 &')

    def corrmidelon(self):
        sacco['opti0'].command_inout("On", [0])

    def corrmindelsb(self):
        sacco['opti0'].command_inout('Off')

    def configura_mimo_fastscan(self):
        os.system('/runtime/bin/mimoconfig opt/fel02/fine_delay_sl.01 &')

    def fastdelayscanA(self):
        #100fs
        sacco['fastdelayscan'].write_attribute('ActuatorRangeValues', [480, 15]) #boh, 100fs
        sacco['fastdelayscan'].write_attribute('ActuatorRMKickValues', [30, 1.5]) #boh, 10fs
        sacco['fastdelayscan'].write_attribute('BatchProgramVector', [7, 0, 1])
        time.sleep(0.1)
        sacco['fastdelayscan'].command_inout('On')

    def fastdelayscanB(self):
        #400fs
        sacco['fastdelayscan'].write_attribute('ActuatorRangeValues', [480, 60]) #boh, 400fs
        sacco['fastdelayscan'].write_attribute('ActuatorRMKickValues', [30, 3]) #boh, 20fs
        sacco['fastdelayscan'].write_attribute('BatchProgramVector', [7, 0, 1])
        time.sleep(0.1)
        sacco['fastdelayscan'].command_inout('On')

    def fastdelayscanC(self):
        #3ps
        sacco['fastdelayscan'].write_attribute('ActuatorRangeValues', [480, 50])
        sacco['fastdelayscan'].write_attribute('ActuatorRMKickValues', [30, 5])
        sacco['fastdelayscan'].write_attribute('BatchProgramVector', [7, 1, 0, 7, 0, 1])
        time.sleep(0.1)
        sacco['fastdelayscan'].command_inout('On')

    def trls4go(self):
        gol = float(self.timing_trls4_setposition.text())
        sacco['trls4'].write_attribute('Position', [gol])

    def trls4stop(self):
        sacco['trls4'].command_inout('Stop')

    def trls4vai(self):
        gol = float(self.timing_trls4_realtivestep.text())
        sacco['trls4'].command_inout('Forward', [gol])

    def trls4torna(self):
        gol = float(self.timing_trls4_realtivestep.text())
        sacco['trls4'].command_inout('Backward', [gol])

    def trls4speed(self):
        gol = float(self.timing_trls4_speedwrite.text())
        sacco['trls4'].write_attribute('Speed', [gol])

    def trls8go(self):
        gol = float(self.timing_trls8_setposition.text())
        sacco['trls8'].write_attribute('Position', [gol])

    def trls8stop(self):
        sacco['trls8'].command_inout('Stop')

    def trls8vai(self):
        gol = float(self.timing_trls8_realtivestep.text())
        sacco['trls8'].command_inout('Forward', [gol])

    def trls8torna(self):
        gol = float(self.timing_trls8_realtivestep.text())
        sacco['trls8'].command_inout('Backward', [gol])

    def trls8speed(self):
        gol = float(self.trlssl08_editSPEED.text())
        sacco['trls8'].write_attribute('Speed', [gol])

# funzioni - pointing
    def campi_target_pointing(self):
        self.pointing_optimization_target.hide()
        self.pointing_optimization_targetlist.show()
        self.pointing_optimization_targetchange.hide()
        self.pointing_optimization_targetapply.show()

    def cambio_target_pointing(self):
        sacco['opti1'].write_attribute('TargetName', str(self.pointing_optimization_targetlist.currentText()))
        sacco['opti2'].write_attribute('TargetName', str(self.pointing_optimization_targetlist.currentText()))
        sacco['opti3'].write_attribute('TargetName', str(self.pointing_optimization_targetlist.currentText()))
        sacco['opti4'].write_attribute('TargetName', str(self.pointing_optimization_targetlist.currentText()))
        self.pointing_optimization_target.show()
        self.pointing_optimization_targetlist.hide()
        self.pointing_optimization_targetchange.show()
        self.pointing_optimization_targetapply.hide()

    def lancia_pannello_pointing_feedback(self):
        if chevergognafarloamano == 'F1O' or chevergognafarloamano == 'F1T':
            os.system('/runtime/bin/ftfmaster sl/feedback/rtltf_fel01.01 -title FEL01_transverse_feedback_"rtltf_fel01.01" --laser &')
        elif chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F2T':
            os.system('/runtime/bin/ftfmaster sl/feedback/rtltf_fel02.01 -title FEL02_transverse_feedback_"rtltf_fel02.01" --laser &')

    def change_shake_ccd1_state(self):
        if self.pointing_optimization_shake1cb.isChecked():
            sacco['parametrisalvati'].write_attribute('fel_fb_contshake_ccd1', True)
        else:
            sacco['parametrisalvati'].write_attribute('fel_fb_contshake_ccd1', False)

    def change_shake_ccd2_state(self):
        if self.pointing_optimization_shake2cb.isChecked():
            sacco['parametrisalvati'].write_attribute('fel_fb_contshake_ccd2', True)
        else:
            sacco['parametrisalvati'].write_attribute('fel_fb_contshake_ccd2', False)

    def shake_ccd1_edit(self):
        self.pointing_optimization_shake1magR.hide()
        self.pointing_optimization_shake1magW.show()

    def shake_ccd1_edit_done(self):
        sacco['parametrisalvati'].write_attribute('fel_fb_contshake_ampl_ccd1', float(self.pointing_optimization_shake1magW.text()))
        self.pointing_optimization_shake1magW.hide()
        self.pointing_optimization_shake1magR.show()

    def shake_ccd2_edit(self):
        self.pointing_optimization_shake2magR.hide()
        self.pointing_optimization_shake2magW.show()

    def shake_ccd2_edit_done(self):
        sacco['parametrisalvati'].write_attribute('fel_fb_contshake_ampl_ccd2', float(self.pointing_optimization_shake2magW.text()))
        self.pointing_optimization_shake2magW.hide()
        self.pointing_optimization_shake2magR.show()

    def fbFEL_acceso(self):
        sacco['felfb'].command_inout('On')

    def fbFEL_standby(self):
        sacco['felfb'].command_inout('Standby')

    def fbFEL_crocettalo(self):
        sacco['ccd1'].command_inout('SetReference')
        sacco['ccd2'].command_inout('SetReference')

    def checkboxreference(self):
        if not self.pointing_feedback_fbkeep_reference.isChecked():
            self.msgBox = QMessageBox()
            self.msgBox.setIcon(QMessageBox.Question)
            self.msgBox.setStandardButtons(QMessageBox.Ok | QMessageBox.Cancel)
            self.msgBox.setText("Are you sure? If the feedback is working this checkbox has to be enabled. You need to disable this checkbox ONLY before restarting the feedback after an alignment done with feedback OFF or STANDBY. Also it is always usefull to save the current trajectory (with button SAVE memory*) before disable this checkbox, if this is not done please Cancel, save trajectory and then, if it is needed, disable KeepReference")
            risp = self.msgBox.exec_()
            if risp == 1024:
                sacco['felfb'].write_attribute('KeepReferenceOn', False)
        elif self.pointing_feedback_fbkeep_reference.isChecked():
            sacco['felfb'].write_attribute('KeepReferenceOn', True)

    def pointingfeedbackinslowgain(self):
        sacco['fbseqslow'].Start()

    def pointingfeedbackinfastgain(self):
        sacco['fbseqfast'].Start()

    def relax_felfb(self):
        sacco['relaxfelfb'].command_inout('On')

    def unrelax_felfb(self):
        sacco['relaxfelfb'].command_inout('Standby')

    def fbFEL_saveRef1(self):
        tmp = sacco['felfb'].RefTrajHor
        x = tmp
        tmp = sacco['felfb'].RefTrajVer
        y = tmp
        sacco['parametrisalvati'].write_attribute('fb_fel_traj1', [x[0], y[0], x[1], y[1]])

    def fbFEL_restoreRef1(self):
        tmp = sacco['parametrisalvati'].fb_fel_traj1
        sacco['felfb'].write_attribute('RefTrajHor', [tmp[0], tmp[2]])
        sacco['felfb'].write_attribute('RefTrajVer', [tmp[1], tmp[3]])

    def fbFEL_saveRef2(self):
        tmp = sacco['felfb'].RefTrajHor
        x = tmp
        tmp = sacco['felfb'].RefTrajVer
        y = tmp
        sacco['parametrisalvati'].write_attribute('fb_fel_traj2', [x[0], y[0], x[1], y[1]])

    def fbFEL_restoreRef2(self):
        tmp = sacco['parametrisalvati'].fb_fel_traj2
        sacco['felfb'].write_attribute('RefTrajHor', [tmp[0], tmp[2]])
        sacco['felfb'].write_attribute('RefTrajVer', [tmp[1], tmp[3]])

    def fbFEL_retrH1more(self):
        gol = float(self.pointing_trajectory_1passo.text())
        tmp = sacco['felfb'].RefTrajHor
        p1 = tmp[0]+gol
        p2 = tmp[1]
        sacco['felfb'].write_attribute('RefTrajHor', [p1, p2])

    def fbFEL_retrH1less(self):
        gol = float(self.pointing_trajectory_1passo.text())
        tmp = sacco['felfb'].RefTrajHor
        p1 = tmp[0]-gol
        p2 = tmp[1]
        sacco['felfb'].write_attribute('RefTrajHor', [p1, p2])

    def fbFEL_retrH2more(self):
        gol = float(self.pointing_trajectory_2passo.text())
        tmp = sacco['felfb'].RefTrajHor
        p1 = tmp[0]
        p2 = tmp[1]+gol
        sacco['felfb'].write_attribute('RefTrajHor', [p1, p2])

    def fbFEL_retrH2less(self):
        gol = float(self.pointing_trajectory_2passo.text())
        tmp = sacco['felfb'].RefTrajHor
        p1 = tmp[0]
        p2 = tmp[1]-gol
        sacco['felfb'].write_attribute('RefTrajHor', [p1, p2])

    def fbFEL_retrV1more(self):
        gol = float(self.pointing_trajectory_1passo.text())
        tmp = sacco['felfb'].RefTrajVer
        p1 = tmp[0]+gol
        p2 = tmp[1]
        sacco['felfb'].write_attribute('RefTrajVer', [p1, p2])

    def fbFEL_retrV1less(self):
        gol = float(self.pointing_trajectory_1passo.text())
        tmp = sacco['felfb'].RefTrajVer
        p1 = tmp[0]-gol
        p2 = tmp[1]
        sacco['felfb'].write_attribute('RefTrajVer', [p1, p2])

    def fbFEL_retrV2more(self):
        gol = float(self.pointing_trajectory_2passo.text())
        tmp = sacco['felfb'].RefTrajVer
        p1 = tmp[0]
        p2 = tmp[1]+gol
        sacco['felfb'].write_attribute('RefTrajVer', [p1, p2])

    def fbFEL_retrV2less(self):
        gol = float(self.pointing_trajectory_2passo.text())
        tmp = sacco['felfb'].RefTrajVer
        p1 = tmp[0]
        p2 = tmp[1]-gol
        sacco['felfb'].write_attribute('RefTrajVer', [p1, p2])

    def lancia_opt1(self):
        os.system('/runtime/bin/correlation_minimizer f/optimization/corrmin_f.01 &')

    def lancia_opt2(self):
        os.system('/runtime/bin/correlation_minimizer f/optimization/corrmin_f.02 &')

    def lancia_opt3(self):
        os.system('/runtime/bin/correlation_minimizer f/optimization/corrmin_f.03 &')

    def lancia_opt4(self):
        os.system('/runtime/bin/correlation_minimizer f/optimization/corrmin_f.04 &')

    def opt1on(self):
        sacco['opti1'].command_inout("On", [0])

    def opt1sb(self):
        sacco['opti1'].command_inout('Off')

    def opt2on(self):
        sacco['opti2'].command_inout("On", [0])

    def opt2sb(self):
        sacco['opti2'].command_inout('Off')

    def opt3on(self):
        sacco['opti3'].command_inout("On", [0])

    def opt3sb(self):
        sacco['opti3'].command_inout('Off')

    def opt4on(self):
        sacco['opti4'].command_inout("On", [0])

    def opt4sb(self):
        sacco['opti4'].command_inout('Off')

    def shake_on(self):
        peso1 = float(self.pointing_optimization_shake1magR.text())
        peso2 = float(self.pointing_optimization_shake2magR.text())
        shake1state = self.pointing_optimization_shake1cb.isChecked()
        shake2state = self.pointing_optimization_shake2cb.isChecked()
        sacco['felfb'].write_attribute('OptimizeContinuous', True)
        time.sleep(0.01)
        sacco['felfb'].write_attribute('OptimizeGain', 0)
        if shake1state:
            sacco['felfb'].command_inout('ScanSetRange', [0, peso1, peso1*0.9, peso1, peso1*0.9, 450, 1.0, -1, 31.0])
        else:
            sacco['felfb'].command_inout('ScanSetRange', [0, peso1/100000, peso1/100000, peso1/100000, peso1/100000, 450, 1.0, -1, 31.0])
        if shake2state:
            sacco['felfb'].command_inout('ScanSetRange', [1, peso2, peso2*0.9, peso2, peso2*0.9, 350, 1.0, -1, 31.0])
        else:
            sacco['felfb'].command_inout('ScanSetRange', [1, peso2/100000, peso2/100000, peso2/100000, peso2/100000, 350, 1.0, -1, 31.0])
        time.sleep(0.01)
        sacco['felfb'].write_attribute('OptimizeState', np.int32(2))

    def shake_off(self):
        sacco['felfb'].write_attribute('OptimizeState', np.int32(0))
        sacco['opti4'].command_inout('Off')
        sacco['opti3'].command_inout('Off')
        sacco['opti1'].command_inout('Off')
        sacco['opti2'].command_inout('Off')

    def lancia_CCD1(self):
        if chevergognafarloamano == 'F1O' or chevergognafarloamano == 'F1T':
            os.system('/runtime/bin/gigecam sl/diagnostics/ccd_sl.05 ccd_sl.05 --calibration --refresh=1000 -title SL_FEL1_bereadboard_steering_1_"ccd_sl.05" &')
        elif chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F2T':
            os.system('/runtime/bin/gigecam sl/diagnostics/ccd_sl.10 ccd_sl.10 --calibration --refresh=1000 -title SL_FEL2_bereadboard_steering_1_"ccd_sl.10" &')

    def lancia_CCD2(self):
        if chevergognafarloamano == 'F1O' or chevergognafarloamano == 'F1T':
            os.system('/runtime/bin/gigecam sl/diagnostics/ccd_sl.07 ccd_sl.07 --calibration --refresh=1000 -title SL_FEL1_Virtual_Undulator_"ccd_sl.07" &')
        elif chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F2T':
            os.system('/runtime/bin/gigecam sl/diagnostics/ccd_sl.12 ccd_sl.12 --calibration --refresh=1000 -title SL_FEL2_Virtual_Undulator_"ccd_sl.12" &')

    def lancia_motor1(self):
        if chevergognafarloamano == 'F1O' or chevergognafarloamano == 'F1T':
            os.system('/runtime/bin/mount2axes sl/motor/kom_sl.03 -title SL_FEL01_beam_steering_1_"kom_sl.03" &')
        elif chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F2T':
            os.system('/runtime/bin/mount2axes sl/motor/kom_sl.05 -title SL_FEL02_beam_steering_1_"kom_sl.05" &')

    def lancia_motor2(self):
        if chevergognafarloamano == 'F1O' or chevergognafarloamano == 'F1T':
            os.system('/runtime/bin/mount2axes sl/motor/kom_fel01_sl.01 -title SL_FEL01_beam_steering_2_"kom_fel01_sl.01" &')
        elif chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F2T':
            os.system('/runtime/bin/mount2axes sl/motor/kom_fel02_sl.01 -title SL_FEL02_beam_steering_2_"kom_fel02_sl.01" &')

    def lancia_piezo1(self):
        if chevergognafarloamano == 'F1O' or chevergognafarloamano == 'F1T':
            os.system('/runtime/bin/slutiptilt sl/piezo/tiptilt_sl.01 -title tiptilt_FEL01_UP_"tiptilt_sl.01" &')
        elif chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F2T':
            os.system('/runtime/bin/slutiptilt sl/piezo/tiptilt_sl.09 -title tiptilt_FEL02_UP_"tiptilt_sl.09" &')

    def lancia_piezo2(self):
        if chevergognafarloamano == 'F1O' or chevergognafarloamano == 'F1T':
            os.system('/runtime/bin/slutiptilt sl/piezo/tiptilt_sl.02 -title tiptilt_FEL01_DOWN_"tiptilt_sl.02" &')
        elif chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F2T':
            os.system('/runtime/bin/slutiptilt sl/piezo/tiptilt_sl.05 -title tiptilt_FEL02_DOWN_"tiptilt_sl.05" &')

    def lancia_hdbtool(self):
        os.system('python /home/lfo/devel/fermi/panels/laser/slcommands/slrecall_hdb.py &')

    def lancia_alignmenttool(self):
        if chevergognafarloamano == 'F1O' or chevergognafarloamano == 'F1T':
            os.system('python /home/lfo/devel/fermi/panels/laser/slcommands/slmotorforfel1.py &')
        elif chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F2T':
            os.system('python /home/lfo/devel/fermi/panels/laser/slcommands/slmotorforfel2.py &')

    def lancia_schermo1_ccd(self):
        if chevergognafarloamano == 'F1O' or chevergognafarloamano == 'F1T':
            os.system('/runtime/bin/gigecam sfel01/diagnostics/mscrccd_sfel01.02 mscrccd_sfel01.02 --scr=sfel01/diagnostics/mscr_sfel01.02 &')
        elif chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F2T':
            os.system('/runtime/bin/gigecam sfel02/diagnostics/mscrccd_sfel02.02 mscrccd_sfel02.02 --scr=sfel02/diagnostics/mscr_sfel02.02 &')

    def lancia_schermo1_schermo(self):
        if chevergognafarloamano == 'F1O' or chevergognafarloamano == 'F1T':
            os.system('/runtime/bin/mscr sfel01/diagnostics/mscr_sfel01.02 &')
        elif chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F2T':
            os.system('/runtime/bin/mscr sfel02/diagnostics/mscr_sfel02.02 &')

    def schermo1attenuaperseed(self):
        sacco['schermo1'].write_attribute('Polar1Attenuation', 0.0)
        sacco['schermo1ccd'].write_attribute('Exposure', 200000)
        sacco['schermo1ccd'].write_attribute('Gain', 25.8)

    def schermo1attenuaperebeam(self):
        sacco['schermo1'].write_attribute('Polar1Attenuation', 80.0)
        sacco['schermo1ccd'].write_attribute('Exposure', 100)
        sacco['schermo1ccd'].write_attribute('Gain', 0.0)

    def lancia_schermo2_ccd(self):
        if chevergognafarloamano == 'F1O' or chevergognafarloamano == 'F1T':
            os.system('/runtime/bin/gigecam fel01/diagnostics/mscrccd_fel01.01 mscrccd_fel01.01 --scr=fel01/mover2d/mscr_fel01.01 &')
        elif chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F2T':
            os.system('/runtime/bin/gigecam fel02/diagnostics/mscrccd_fel02.01 mscrccd_fel02.01 --scr=fel02/mover2d/mscr_fel02.01 &')

    def lancia_schermo2_schermo(self):
        if chevergognafarloamano == 'F1O' or chevergognafarloamano == 'F1T':
            os.system('/runtime/bin/mscrifc-g2 fel01/mover2d/mscr_fel01.01 fel01/diagnostics/mscr_io_fel01.01 fel01/diagnostics/mscr_rots_fel01.01  fel01/mps/mscr_fel01.01 -e &')
        elif chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F2T':
            os.system('/runtime/bin/mscrifc-g2 fel02/mover2d/mscr_fel02.01 fel02/diagnostics/mscr_io_fel02.01 fel02/diagnostics/mscr_rots_fel02.01  fel02/mps/mscr_fel02.01 -e &')

    def schermo2attenuaperseed(self):
        sacco['schermo2_filter'].command_inout('GoToReference')
        aspetta = sacco['schermo2_filter'].read_attribute('State')
        while str(aspetta.value) == 'MOVING':
            time.sleep(0.5)
            aspetta = sacco['schermo2_filter'].read_attribute('State')
        sacco['schermo2ccd'].write_attribute('Exposure', 100000)
        sacco['schermo2ccd'].write_attribute('Gain', 21.4)

    def schermo2attenuaperebeam(self):
        sacco['schermo2_filter'].command_inout('GoToReference')
        time.sleep(0.1)
        aspetta = sacco['schermo2_filter'].read_attribute('State')
        while str(aspetta.value) == 'MOVING':
            time.sleep(0.2)
            aspetta = sacco['schermo2_filter'].read_attribute('State')
        sacco['schermo2_filter'].command_inout('NextFilter')
        time.sleep(0.1)
        aspetta = sacco['schermo2_filter'].read_attribute('State')
        while str(aspetta.value) == 'MOVING':
            time.sleep(0.5)
            aspetta = sacco['schermo2_filter'].read_attribute('State')
        sacco['schermo2_filter'].command_inout('NextFilter')
        time.sleep(0.1)
        aspetta = sacco['schermo2_filter'].read_attribute('State')
        while str(aspetta.value) == 'MOVING':
            time.sleep(0.5)
            aspetta = sacco['schermo2_filter'].read_attribute('State')
        sacco['schermo2ccd'].write_attribute('Exposure', 100)
        sacco['schermo2ccd'].write_attribute('Gain', 0.0)

    def lancia_schermo3_ccd(self):
        if chevergognafarloamano == 'F1O' or chevergognafarloamano == 'F1T':
            os.system('/runtime/bin/gigecam iufel01/diagnostics/mscrccd_iufel01.02 mscrccd_iufel01.02 --scr=iufel01/mover2d/mscr_iufel01.02 &')
        elif chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F2T':
            os.system('/runtime/bin/gigecam iufel02/diagnostics/mscrccd_iufel02.02 mscrccd_iufel02.02 --scr=iufel02/mover2d/mscr_iufel02.02 &')

    def lancia_schermo3_schermo(self):
        if chevergognafarloamano == 'F1O' or chevergognafarloamano == 'F1T':
            os.system('/runtime/bin/mscrifc-g2 iufel01/mover2d/mscr_iufel01.02 iufel01/diagnostics/mscr_io_iufel01.02 iufel01/diagnostics/mscr_rots_iufel01.02 iufel01/mps/mscr_iufel01.02 -e &')
        elif chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F2T':
            os.system('/runtime/bin/mscrifc-g2 iufel02/mover2d/mscr_iufel02.02 iufel02/diagnostics/mscr_io_iufel02.02 iufel02/diagnostics/mscr_rots_iufel02.02 iufel02/mps/mscr_iufel02.02 -e &')

    def schermo3attenuaperseed(self):
        sacco['schermo3'].command_inout('GoToReference')
        sacco['schermo3ccd'].write_attribute('Exposure', 200000)
        sacco['schermo3ccd'].write_attribute('Gain', 25.8)

    def schermo3attenuaperebeam(self):
        sacco['schermo3'].command_inout('GoToReference')
        time.sleep(0.3)
        sacco['schermo3'].command_inout('NextFilter')
        sacco['schermo3ccd'].write_attribute('Exposure', 100)
        sacco['schermo3ccd'].write_attribute('Gain', 0.0)

    def lancia_iride(self):
        if chevergognafarloamano == 'F1O' or chevergognafarloamano == 'F1T':
            os.system('/runtime/bin/standa8smc1 sl/motor/iris_sl.02 -title FEL01_IRIS_"iris_sl.02" &')
        elif chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F2T':
            os.system('/runtime/bin/standa8smc1 sl/motor/iris_sl.01 -title FEL02_IRIS_"iris_sl.01" &')

    def spegniogniottimizzazione(self):
        sacco['felfb'].write_attribute('OptimizeState', np.int32(0))
        time.sleep(0.01)
        sacco['felfb'].write_attribute('OptimizeGain', 0)
        time.sleep(0.01)
        sacco['felfb'].write_attribute('OptimizeContinuous', False)
        sacco['opti1'].command_inout('Off')
        sacco['opti2'].command_inout('Off')
        sacco['opti3'].command_inout('Off')
        sacco['opti4'].command_inout('Off')

    def dajediottimizzazionestandard(self):
        sacco['opti1'].command_inout('Off')
        sacco['opti2'].command_inout('Off')
        sacco['opti3'].command_inout('Off')
        sacco['opti4'].command_inout('Off')
        sacco['felfb'].write_attribute('OptimizeContinuous', False)
        time.sleep(0.01)
        sacco['felfb'].write_attribute('OptimizeGain', 1)
        time.sleep(0.01)
        sacco['felfb'].command_inout('ScanSetRange', [0, 0.36, 0.14, 0.36, 0.14, 450, 1.0, 399827769, 31.0]) #rumoroso
        time.sleep(0.01)
        sacco['felfb'].command_inout('ScanSetRange', [1, 0.20, 0.10, 0.20, 0.10, 335, 1.0, 399827769, 31.0]) #rumoroso

    def dajediottimizzazionestandardsenzafine(self):
        sacco['opti1'].command_inout('Off')
        sacco['opti2'].command_inout('Off')
        sacco['opti3'].command_inout('Off')
        sacco['opti4'].command_inout('Off')
        sacco['felfb'].write_attribute('OptimizeContinuous', True)
        time.sleep(0.01)
        sacco['felfb'].write_attribute('OptimizeGain', 1)
        time.sleep(0.01)
        sacco['felfb'].command_inout('ScanSetRange', [0, 0.15,  0.14,  0.15, 0.14, 450,  1,  399827769, 31]) #rumoroso
        time.sleep(0.01)
        sacco['felfb'].command_inout('ScanSetRange', [1, 0.07,  0.05,  0.07, 0.05, 350,  1,  399827769, 31]) #rumoroso
        time.sleep(0.01)
        sacco['felfb'].write_attribute('OptimizeState', np.int32(2))

    def dajediottimizzazionestandardsenzafinemacoipesi(self):
        peso1 = float(self.pointing_optimization_shake1magR.text())
        peso2 = float(self.pointing_optimization_shake2magR.text())
        sacco['opti1'].command_inout('Off')
        sacco['opti2'].command_inout('Off')
        sacco['opti3'].command_inout('Off')
        sacco['opti4'].command_inout('Off')
        sacco['felfb'].write_attribute('OptimizeContinuous', True)
        time.sleep(0.01)
        sacco['felfb'].write_attribute('OptimizeGain', 1)
        time.sleep(0.01)
        sacco['felfb'].command_inout('ScanSetRange', [0, peso1,  peso1*0.8,  peso1, peso1*0.8, 450,  1,  399827769, 31]) #rumoroso
        time.sleep(0.01)
        sacco['felfb'].command_inout('ScanSetRange', [1, peso2,  peso2*0.8,  peso2, peso2*0.8, 350,  1,  399827769, 31]) #rumoroso
        time.sleep(0.01)
        sacco['felfb'].write_attribute('OptimizeState', np.int32(2))

    def lanciafbconfigure(self):
        if chevergognafarloamano == 'F1O' or chevergognafarloamano == 'F1T':
            os.system('/runtime/bin/ftfconfig sl/feedback/rtltf_fel01.01 --laser &')
        elif chevergognafarloamano == 'F2O' or chevergognafarloamano == 'F2T':
            os.system('/runtime/bin/ftfconfig sl/feedback/rtltf_fel02.01 --laser &')

    def dajedishakeemincorglobale(self):
        peso1 = float(self.pointing_optimization_shake1magR.text())
        peso2 = float(self.pointing_optimization_shake2magR.text())
        sacco['felfb'].command_inout('ScanSetRange', [0, peso1, peso1*0.9, peso1, peso1*0.9, 450, 1.0, -1, 31.0])
        time.sleep(0.01)
        sacco['felfb'].command_inout('ScanSetRange', [1, peso2, peso2*0.9, peso2, peso2*0.9, 350, 1.0, -1, 31.0])
        time.sleep(0.01)
        sacco['felfb'].write_attribute('OptimizeContinuous', True)
        time.sleep(0.01)
        sacco['felfb'].write_attribute('OptimizeGain', 0)
        time.sleep(0.01)
        sacco['felfb'].write_attribute('OptimizeState', np.int32(2))
        sacco['opti1'].command_inout("On", [0])
        sacco['opti2'].command_inout("On", [0])
        sacco['opti3'].command_inout("On", [0])
        sacco['opti4'].command_inout("On", [0])

    def dajedishakeemincorsolovirtuale(self):
        peso2 = float(self.pointing_optimization_shake2magR.text())
        sacco['felfb'].command_inout('ScanSetRange', [0, peso2/100000, peso2/100000, peso2/100000, peso2/100000, 450, 1.0, -1, 31.0])
        time.sleep(0.01)
        sacco['felfb'].command_inout('ScanSetRange', [1, peso2, peso2*0.9, peso2, peso2*0.9, 350, 1.0, -1, 31.0])
        time.sleep(0.01)
        sacco['felfb'].write_attribute('OptimizeContinuous', True)
        time.sleep(0.01)
        sacco['felfb'].write_attribute('OptimizeGain', 0)
        time.sleep(0.01)
        sacco['felfb'].write_attribute('OptimizeState', np.int32(2))
        sacco['opti3'].command_inout("On", [0])
        sacco['opti4'].command_inout("On", [0])
        sacco['opti1'].command_inout('Off')
        sacco['opti2'].command_inout('Off')

    def dajedimicorglobale(self):
        sacco['opti1'].command_inout("On", [0])
        sacco['opti2'].command_inout("On", [0])
        sacco['opti3'].command_inout("On", [0])
        sacco['opti4'].command_inout("On", [0])

    def dajedimincorsolovirtuale(self):
        sacco['opti3'].command_inout("On", [0])
        sacco['opti4'].command_inout("On", [0])
        sacco['opti1'].command_inout('Off')
        sacco['opti2'].command_inout('Off')

# funzioni - altro
    def faqualcosa(self):
        print('ao')
        print([self.width(), self.height()])
        epilessia1 = (150 + np.random.random_integers(100), 150 + np.random.random_integers(100), 150 + np.random.random_integers(100))
        epilessia2 = (150 + np.random.random_integers(100), 150 + np.random.random_integers(100), 150 + np.random.random_integers(100))
        epilessia3 = (150 + np.random.random_integers(100), 150 + np.random.random_integers(100), 150 + np.random.random_integers(100))
        self.setStyleSheet("background-color: rgb" + str(epilessia1) + "")
        self.casellamessaggi.setStyleSheet("background-color: rgb" + str(epilessia2) + "")
        self.antistress.setStyleSheet("background-color: rgb" + str(epilessia3) + "")


class LineEditRO(QLineEdit):
    def __init__(self):
        super(LineEditRO, self).__init__()
        self.setReadOnly(1)
        self.setStyleSheet("background-color: rgb(200, 200, 200)")
        self.setFont(font_importante)


class QHLine(QFrame):
    def __init__(self):
        super(QHLine, self).__init__()
        self.setFrameShape(QFrame.HLine)
        self.setFrameShadow(QFrame.Sunken)


class QVLine(QFrame):
    def __init__(self):
        super(QVLine, self).__init__()
        self.setFrameShape(QFrame.VLine)
        self.setFrameShadow(QFrame.Sunken)

#####################################################################################
if __name__ == '__main__':
    app = QApplication([])
    try:
        tmpdim = sys.argv[1].split('x')
        larghezzaaltezza = [float(tmpdim[0]), float(tmpdim[1])]
    except IndexError:
        screen = QDesktopWidget().screenGeometry()
        larghezzaaltezza = [screen.width(), screen.height()]
    if max(larghezzaaltezza) > 3000:
        dimensione = max(larghezzaaltezza)*0.35
    elif max(larghezzaaltezza) > 2000:
        dimensione = max(larghezzaaltezza)*0.5
    elif max(larghezzaaltezza) > 1000:
        dimensione = max(larghezzaaltezza)*0.6
    else:
        dimensione = max(larghezzaaltezza)*1.5
    font_grande = QFont("Arial", round(dimensione/40.0), -1, False)
    font_medio = QFont("Arial", round(dimensione/100.0), -1, True)
    font_importante = QFont("Arial", round(dimensione/120.0), 1, False)
    font_pannello = QFont("Arial", round(dimensione/130.0), -1, False)
    app.setFont(font_pannello)
    window = MainWindow()
    window.resize(610, 480)
    window.show()
    app.exec_()

